/* Create a node of type Observation */

MERGE (
   ob:Observation
   {
      id     : '${OB_id}',      /* <-- observation_stable_id */
      type   : 'Observation',
      subtype: '${OB_type}'     /* <-- observation_type */
   }
)

ON CREATE SET
   ob.ageingFactors             = [${OB_ageing_factors}],

   ob.lifespanEffectSignificant = ${OB_lifespan_effect_significant},   /* <-- lifespan_effect_significant */
   ob.lifespanChange            = ${OB_lifespan_change},               /* <-- lifespan_change */
   ob.lifespanMeasure           = ${OB_lifespan_measure},              /* <-- lifespan_measure */

   ob.homologyDatabase          = ${OB_homology_database},             /* <-- e.g. 'HomoloGene' */
   ob.homologyGroupID           = ${OB_homology_group_id},             /* <-- e.g. homologene_id */

   ob.created = timestamp ()

ON MATCH SET
   ob.ageingFactors             = [${OB_ageing_factors}],

   ob.lifespanEffectSignificant = ${OB_lifespan_effect_significant},   /* <-- lifespan_effect_significant */
   ob.lifespanChange            = ${OB_lifespan_change},               /* <-- lifespan_change */
   ob.lifespanMeasure           = ${OB_lifespan_measure},              /* <-- lifespan_measure */

   ob.homologyDatabase          = ${OB_homology_database},             /* <-- e.g. 'HomoloGene' */
   ob.homologyGroupID           = ${OB_homology_group_id}              /* <-- e.g. homologene_id */
