
##---------------------------Class Arguments---------------------------------------##
class Arguments (object):
   ##------------------------Wrap Dictionary Functions-----------------------------##
   def __init__ (self, *args, **kwargs):
      self.update (*args, **kwargs)
      #if (type (args) == Arguments):
      #   self.__dict__.update (args.__dict__)
      #elif (isinstance (args, dict) ):
      #   self.__dict__.update (args)



   ##------------------------Wrap Dictionary Functions-----------------------------##
   def update (self, *args, **kwargs):
      for arg in args:
         if (type (arg) == Arguments):
            self.__dict__.update (arg.__dict__)
         elif (isinstance (arg, dict) ):
            self.__dict__.update (arg)
         elif (type (arg) == list or type (arg) == tuple):
            for arg_ in arg:
               self.update (arg_)
         #else:

      #self.__dict__.update (kwargs)
      for key, value in kwargs.items ():
         __dict, key = self._interpretKey (key)
         __dict.__setitem__ (key, value)

      return self

   def __contains__ (self, *args, **kwargs):   # Operator in
      return self.__dict__.__contains__(*args, **kwargs)

   def __getitem__ (self, args):   # Operator []
      if type (args) == tuple and args not in self.__dict__:
         ret = []
         for arg in list (args):
            ret.append (self.__dict__.__getitem__(arg) )
         return tuple (ret)
      else:
         return self.__dict__.__getitem__(args)

   def __setitem__ (self, *args, **kwargs):
      return self.__dict__.__setitem__(*args, **kwargs)

   def __iter__ (self):
      return self.__dict__.items().__iter__()

   def __len__ (self):
      return self.__dict__.__len__()

   def has (self, key):
      return (key in self.__dict__.keys () )

   def items (self):
      return self.__dict__.items()

   def keys (self):
      return self.__dict__.keys()

   def values (self):
      return self.__dict__.values()

   #def fromkeys (self, iterable, value):
   #   return self.__dict__.fromkeys(iterable, value)



   ##------------------------Start __call__----------------------------------------##
   def __call__ (self, *args, **kwargs):   # Operator ()
      """
         Returns one or multiple arguments.

         Args:
            argument | list of arguments:
            fcn: callback function like in JavaScript array.forEach
            argc: forward only this amount of args to fcn; supported: 1, 2, 3
            astype: only for list of arguments; return arguments in this container; supported: dict, list, tuple, set, iter, enumerate, 'generator', 'yield'
            default: only for one argument; return this value if argument don't exist and missing_ok=True
      """
      if len (args) == 1:
         astype = kwargs.get ('astype', None)
      else:
         astype = kwargs.get ('astype', dict)

      if len (args) == 1 and astype == None:
         res = list (self.each (*args, **kwargs) )
         if len (res) >= 1: return res[0][1]
         else: return kwargs.get ('default', None)
      elif astype == dict:
         return dict (self.each (*args, **kwargs) )
      elif astype == list or astype == tuple or astype == set or astype == iter or astype == enumerate:
         return astype ([value for _, value in self.each (*args, **kwargs)])
      elif astype == 'generator' or astype == 'yield':
         return self.each (*args, **kwargs)
      else:
         raise Exception ("the selected 'astype' is not supported")



   ##------------------------Start __str__-----------------------------------------##
   def __str__ (self, prefix = "", maxlen = 256):
      ret    = ""
      first  = True
      length = 0

      for s in self.__dict__:
         length = max (length, len (s) )

      val = "%%%is" % length

      for s in sorted (self.__dict__.items() ):
         if first == False: ret += "\n"
         first = False
         if type (s[1]) == Arguments:
            ret += prefix + (val % str (s[0]) ) + " = <class Arguments>\n"
            ret += s[1].__str__ (prefix = prefix + (val % str (s[0]) ) + ".", maxlen = maxlen)
         elif type (s[1]) == str:
            if len (s[1]) > maxlen:
               ret += prefix + (val % str (s[0]) ) + " = '" + s[1][:maxlen] + "...'"
            else:
               ret += prefix + (val % str (s[0]) ) + " = '" + s[1] + "'"
         else:
            ss = str(s[1])
            if len (ss) > maxlen:
               ret += prefix + (val % str (s[0]) ) + " = " + ss[:maxlen] + "..."
            else:
               ret += prefix + (val % str (s[0]) ) + " = " + ss

      return (ret)



   ##------------------------Start __getattribute__--------------------------------##
   def __getattribute__ (self, key):
      if key[0] == '_':
         return super(Arguments, self).__getattribute__ (key)
      _dict = super(Arguments, self).__getattribute__ ('__dict__')
      if '__trace__' in _dict and key in _dict:
         if key not in _dict['__trace__']:
            _dict['__trace__'][key] = {'get': 0, 'set': 0}
         _dict['__trace__'][key]['get'] += 1
      return super(Arguments, self).__getattribute__ (key)



   ##------------------------Start __setattr__-------------------------------------##
   def __setattr__ (self, key, value):
      if key[0] == '_':
         return super(Arguments, self).__getattribute__ (key)
      _dict = super(Arguments, self).__getattribute__ ('__dict__')
      if '__trace__' in _dict:
         if key not in _dict['__trace__']:
            _dict['__trace__'][key] = {'get': 0, 'set': 0}
         _dict['__trace__'][key]['set'] += 1
      return super(Arguments, self).__setattr__ (key, value)



   ##------------------------Start each--------------------------------------------##
   def each (self, *args, **kwargs):
      """
         Create a generator.

         Args:
            argument | list of arguments:
            fcn: callback function like in JavaScript array.forEach
            argc: forward only this amount of args to fcn; supported: 1, 2, 3
            missing_ok:

         Return:
            Yield over all defined arguments.
      """
      fcn        = kwargs.get ('fcn',  lambda e: e)
      argc       = kwargs.get ('argc', None)
      missing_ok = kwargs.get ('missing_ok', False)

      if fcn == None:
         raise Exception ("callback function not defined")
      if len (args) == 0: args = self.__dict__.keys ()

      if   argc != None:               pass
      elif hasattr (fcn, 'func_code'): argc = fcn.__code__.co_argcount
      elif hasattr (fcn, '__code__'):  argc = fcn.__code__.co_argcount
      elif hasattr (fcn, '__call__'):  argc = 1
      else: raise Exception ("I don't know how to properly call the callback function")

      #if argc > 3: argc = 1

      if   argc == 1:
         for arg in list (args):
            if missing_ok == True and arg not in self.__dict__: continue
            yield (arg, fcn (self.__dict__.__getitem__(arg) ) )
      elif argc == 2:
         for n, arg in enumerate (args):
            if missing_ok == True and arg not in self.__dict__: continue
            yield (arg, fcn (self.__dict__.__getitem__(arg), n) )
      elif argc == 3:
         for n, arg in enumerate (args):
            if missing_ok == True and arg not in self.__dict__: continue
            yield (arg, fcn (self.__dict__.__getitem__(arg), n, self) )
      else:
         raise Exception ("callback function needs to define between 1 and 3 arguments, but %d are expected" % args)



   ##------------------------Start enableTracing-----------------------------------##
   # Trace the get- and set- operations on the object.
   # This function will enable and reset the statistics.
   # The statictics are saved in the variable  '__trace__'.
   def enableTracing (self):
      self.__dict__['__trace__'] = {}



   ##------------------------Start disableTracing----------------------------------##
   # Disable tracing and delete the statistics.
   def disableTracing (self):
      del self.__dict__['__trace__']



   ##------------------------Start load--------------------------------------------##
   # Load arguments from ini-files
   def load (self, filenames, group = None):
      if filenames == None: return

      if type (filenames) == str:
         filenames = [filenames]

      for filename in filenames:
         with open (filename, 'r') as file:
            self.loadAsIni (file)



   ##------------------------Start loadAsCLI---------------------------------------##
   # Read arguments from CLI like format
   def loadAsCLI (self, args):
      """
         Load arguments from a cmd-line.

         Arguments can have these forms:
            --flag:        Boolean True
            --key=value:   Assignment
            --key value:   Assignment
      """
      if args == None: return

      if type (args) == str:
         try:
            import shlex
            args = shlex.split (args)
         except:
            args = args.split ()   #TODO make this more CLI compatible

      e     = enumerate (args)
      lines = []

      # Interpret options and its values
      for i, arg in e:
         if arg[:2] == '--':
            line = arg[2:]

            if i < len (args) and i+1 < len (args) and args[i+1][:2] != '--':
               line += "=" + args[i+1]
               next (e)

            lines.append (line)

      self.loadAsIni (lines)



   ##------------------------Start loadAsCSV---------------------------------------##
   # Read arguments from a comma separated long line
   def loadAsCSV (self, str):
      if str == None: return

      self.loadAsIni (str.split (",") )   #TODO handle \,



   ##------------------------Start loadAsIni---------------------------------------##
   # Load arguments from an ini-like file handle
   def loadAsIni (self, file):
      for line in file:
         tline = line.strip ()
         pos   = tline.find ('=')

         if len (tline) == 0:
            continue
         elif tline[0] == '#' or tline[0] == ';':   # Comment
            continue
         elif pos == -1:
            key   = tline
            if key[0] == '!':
               key   = key[1:]
               value = False
            else:
               value = True
         else:
            key   = tline[:pos].strip ()
            value = tline[pos+1:].strip ()
            value = self._interpretValue (value)

         if True:            #TODO make it optional
            __dict, key = self._interpretKey (key)
            __dict.__setitem__ (key, value)
         else:
            self.__dict__.__setitem__ (key, value)



   ##------------------------Start _interpretKey-----------------------------------##
   # Interpret value (implement myself to reduce dependencies)
   def _interpretKey (self, key):
      _dict = self.__dict__
      group = key

      if key.find ('.') > 0:   # Allow '.value'
         while True:
            pos = key.find ('.')

            if pos == -1:
               break
            else:
               group = key[:pos]
               key   = key[pos+1:]
               if group not in _dict:
                  _dict[group] = Arguments ()
               _dict = _dict[group]

      return _dict, group



   ##------------------------Start _interpretValue---------------------------------##
   # Interpret value (implement myself to reduce dependencies)
   def _interpretValue (self, value):
      import re   # Import Regular Expression Package

      temp1 = value.lower ()

      if   temp1 == "true" or temp1 == "!false":    # True
         value = True

      elif temp1 == "false" or temp1 == "!true":   # False
         value = False

      elif value == "None":   # None
         value = None

      elif re.match (r"^[-]?[0-9]+([Ee][0-9]+)?$", value):
         # Integer
         value = int (value)

      elif re.match (r"^[-]?[0-9]+(\.[0-9]+)?([Ee][-]?[0-9]+)?$", value):
         # Number
         value = float (value)

      elif value[0] == '{' and value[-1] == '}':
         # Dictionary
         value = eval (value)   #FIXME do not use eval

      elif (value[0] == '"' and value[-1] == '"') or (value[0] == "'" and value[-1] == "'"):
         value = value[1:-1]

      #elif value[0:9] == '<function':
      #   value.find
      #   value = value[9:-1]

      return value



   ##------------------------Start resolveArguments--------------------------------##
   # Replace all occurences of '<[a-zA-Z_]>' with the pointed variable
   def resolveArguments (self, iterations = 3):
      import re   # Import Regular Expression Package

      resolved  = True
      iteration = 0

      while resolved and iteration < iterations:
         resolved   = False   # Restore state to: nothing was resolved, no retry needed
         iteration += 1

         for key, value in self.__dict__.items ():
            if type (value) != str: continue

            finds = [res for res in re.finditer (r"<[a-zA-Z_]+>", value) ]
            temp1 = False

            for res in reversed (finds):
               id = res.group ()[1:-1]
               if self.has (id):
                  temp1 = resolved = True
                  value = value[:res.start()] + str (self[id]) + value[res.end():]

            if temp1:
               self[key] = value



   ##------------------------Start resolveArgument---------------------------------##
   # Replace all occurences of '<[a-zA-Z_]>' with the pointed variable
   def resolveArgument (self, key):
      import re   # Import Regular Expression Package

      value    = self[key]
      resolved = False

      if type (value) != str: return False

      finds = [res for res in re.finditer (r"<[a-zA-Z_]+>", value) ]

      for res in reversed (finds):
         id = res.group ()[1:-1]
         if self.has (id):
            resolved = True
            value = value[:res.start()] + str (self[id]) + value[res.end():]

      if resolved:
         self[key] = value

      return resolved
