#!/usr/bin/env python3

##---------------------------Imports-----------------------------------------------##
import os, sys


CURR_DIR = os.path.dirname (os.path.abspath (__file__) )
BASE_DIR = os.path.dirname (os.path.dirname (os.path.dirname (CURR_DIR) ) )
sys.path.insert (0, os.path.join (BASE_DIR, 'Tools') )
sys.path.insert (0, CURR_DIR)


from Arguments import Arguments



##---------------------------Start Main--------------------------------------------##
def load (configfile, verbose):
   ##------------------------Read Arguments----------------------------------------##
   config = Arguments ()
   config.load (configfile)



   ##------------------------Start vprint------------------------------------------##
   def vprint (v, *argv, **kwargs):
      if verbose >= v:
         print (*argv, **kwargs)


   ##------------------------Create midlayer database------------------------------##
   db = Arguments ()
   db.AF = Arguments ()
   db.AT = Arguments ()
   db.OB = Arguments ()
   db.CT = Arguments ()
   db.GO = Arguments ()
   db.KEGGX = Arguments ()
   db.PW = Arguments ()
   db.SP = Arguments ()
   db.PWbs = Arguments ()
   db.edges = []
   db.edgesLabels = {}
   db.ATmapping = {}



   import converters

   try:
      vprint (2, "Load DB files")

      #
      converters.ATmapping.load (None, db)

      # Nodes
      converters.file1.load  (config.file1, db)
      converters.file3.load  (config.file3, db)
      converters.file6.load  (config.file6, db)
      converters.file7.load  (config.file7, db)
      converters.file8.load  (config.file8, db)
      converters.file10.load (config.file10, db)
      converters.file12.load (config.file12, db)

      # Edges
      converters.file4.load  (config.file4, db)
      converters.file2.load  (config.file2, db)
      converters.file5.load  (config.file5, db)
      converters.file9.load  (config.file9, db)
      converters.file11.load (config.file11, db)

      converters.edges.load (db)

   except Exception as ex:
      print (ex, file = sys.stderr)
      import console; console()


   return db
