
##---------------------------Imports-----------------------------------------------##
import os, sys

from Arguments import Arguments

CURR_DIR = os.path.dirname (os.path.abspath (__file__) )



##---------------------------Start load--------------------------------------------##
def load (db):

   # AF
   # for AF_id, af in db.AF:
   #    # AF - SP
   #    for SP_id in af.AF_species:
   #       db.edges.append ({
   #          'AF_id': AF_id,
   #          'SP_id': SP_id,
   #          'type': 'AF-SP'
   #       })


   # OB
   for OB_id, ob in db.OB:
      # # OB - SP
      # for SP_id in ob.OB_species:
      #    db.edges.append ({
      #       'OB_id': OB_id,
      #       'SP_id': SP_id,
      #       'type': 'OB-SP'
      #    })

      # OB - AF
      for AF_id in ob.OB_ageing_factors:
         db.edges.append ({
            'OB_id': OB_id,
            'AF_id': AF_id,
            'type': 'OB-AF'
         })

   #    # AF - LOB
   #    if ob.OB_type == 'lifespan':
   #       for AF_id in ob.OB_ageing_factors:
   #          db.edges.append ({
   #             'OB_id': OB_id,
   #             'AF_id': AF_id,
   #             'type': 'AF-L-OB'
   #          })

   #    # BAF - OB
   #    for AF_id in ob.OB_base_ageing_factors:
   #       db.edges.append ({
   #          'OB_id': OB_id,
   #          'AF_id': AF_id,
   #          'type': 'AF-OB'
   #       })

   #    for al in ob.OB_allele_types:
   #       # OB - AL - AF
   #       db.edges.append ({
   #          'OB_id': OB_id,
   #          'AF_id': al['AF_id'],
   #          'AL_type': al['AL_type'],
   #          'AL_base': al['AL_base'],
   #          'type': 'OB-AL-AF'
   #       })

   #       # OB - AT
   #       db.edges.append ({
   #          'OB_id': OB_id,
   #          'AT_id': al['AT_id'],
   #          'AL_type': al['AL_type'],
   #          'type': 'OB-AT'
   #       })

   #       # AF - AT
   #       db.edges.append ({
   #          'AF_id': al['AF_id'],
   #          'AT_id': al['AT_id'],
   #          'AL_type': al['AL_type'],
   #          'type': 'AF-AT'
   #       })


   # # CT
   # for CT_id, ct in db.CT:
   #    # CT - OB
   #    for OB_id in ct.CT_observations:
   #       db.edges.append ({
   #          'CT_id': CT_id,
   #          'OB_id': OB_id,
   #          'type': 'OB-CT'
   #       })


   # # GO
   # for GO_id, go in db.GO:
   #    # GO - SP
   #    for SP_id in go.GO_species:
   #       db.edges.append ({
   #          'GO_id': GO_id,
   #          'SP_id': SP_id,
   #          'type': 'GO-SP'
   #       })

   #    # GO - AF
   #    for af in go.GO_ageing_factors:
   #       db.edges.append ({
   #          'GO_id': GO_id,
   #          'AF_id': af['AF_id'],
   #          'GO_qualifier': af['GO_qualifier'],
   #          'type': 'GO-AF'
   #       })


   # # PW
   # for PW_id, pw in db.PW:
   #    # PW - AF
   #    for AF_id in pw.PW_ageing_factors:
   #       db.edges.append ({
   #          'PW_id': PW_id,
   #          'AF_id': AF_id,
   #          'type': 'PW-AF'
   #       })


   # # KEGGX
   # for KEGGX_id, keggx in db.KEGGX:
   #    # KEGGX - SP
   #    for SP_id in keggx.KEGGX_species:
   #       db.edges.append ({
   #          'KEGGX_id': KEGGX_id,
   #          'SP_id': SP_id,
   #          'type': 'KEGGX-SP'
   #       })

   #    # KEGGX - PW
   #    for PW_id in keggx.KEGGX_pathway:
   #       db.edges.append ({
   #          'KEGGX_id': KEGGX_id,
   #          'PW_id': PW_id,
   #          'type': 'PW-KEGGX'
   #       })


   ## Load edge labels
   with open (os.path.join (CURR_DIR, '..', 'edge_labels.csv') ) as file:
      header = file.readline ().strip ().split (',')
      header = header[1:]

      mapping = {
         'AgeingFactor': 'AF',
         'AlleleType': 'AT',
         'Citation': 'CT',
         'GeneOntologyTerm': 'GO',
         'KEGGPathwayExtraGenes': 'KEGGX',
         'Observation': 'OB',
         'Pathway': 'PW',
         'Species': 'SP'
      }

      for line in file:
         labels = line.strip ().split (',')

         for i, label in enumerate (labels[1:]):
            db.edgesLabels['link_' + mapping[labels[0] ] + '_' + mapping[header[i] ] ] = label
