
##---------------------------Imports-----------------------------------------------##
import os, sys

import check

from Arguments import Arguments



##---------------------------Start asbool------------------------------------------##
def interpret (value):
   return Arguments._interpretValue (None, value)



##---------------------------Start load--------------------------------------------##
def load (filename, db):
   with open (filename, 'r') as file:
      header = file.readline ().strip ().split ('\t')

      for line in file:
         tline = line.strip ()
         if len (tline) == 0: continue

         temp1 = tline.split ('\t')
         temp2 = Arguments ()

         # Glue header with values
         for h, t in zip (header, temp1): temp2[h] = t


         # AgeingFactor
         if temp2.entry_stable_id not in db.AF:
            species = [temp2.species] if temp2.species else []

            db.AF[temp2.entry_stable_id] = Arguments (
               AF_id                      = temp2.entry_stable_id,
               AF_type                    = temp2.entry_type,
               AF_name                    = temp2.entry_name,
               AF_synonyms                = set (),
               AF_ncbi_gene_id            = temp2.ncbi_gene_id,
               AF_lifespan_data_available = interpret (temp2.lifespan_data_available),
               AF_putative                = False,

               # Edges
               AF_species                 = set (species)
            )

         else:
            af = db.AF[temp2.entry_stable_id]

            check.setValue (af, 'AF_type', temp2.entry_type)
            check.setValue (af, 'AF_name', temp2.entry_name)
            check.setValue (af, 'AF_ncbi_gene_id', temp2.ncbi_gene_id)
            check.setValue (af, 'AF_lifespan_data_available', interpret (temp2.lifespan_data_available))

            if temp2.species: af.AF_species.add (temp2.species)


         # Species
         if temp2.species and temp2.species not in db.SP:
            db.SP[temp2.species] = Arguments (
               SP_id = temp2.species
            )
