
##---------------------------Imports-----------------------------------------------##
import os, sys

import check

from Arguments import Arguments



##---------------------------Start load--------------------------------------------##
def load (filename, db):
   with open (filename, 'r') as file:
      header = file.readline ().strip ().split ('\t')

      for line in file:
         tline = line.strip ()
         if len (tline) == 0: continue

         temp1 = tline.split ('\t')
         temp2 = Arguments ()

         # Glue header with values
         for h, t in zip (header, temp1): temp2[h] = t


         # KEGGPathwayExtraGenes
         if temp2.biosystem_ncbi_gene_id not in db.KEGGX:
            species = [temp2.species] if temp2.species else []

            db.KEGGX[temp2.biosystem_ncbi_gene_id] = Arguments (
               KEGGX_id                      = temp2.biosystem_ncbi_gene_id,
               KEGGX_type                    = temp2.type_of_gene,
               KEGGX_description             = temp2.gene_description,
               KEGGX_symbol                  = temp2.gene_symbol,
               KEGGX_ncbi_gene_id            = temp2.biosystem_ncbi_gene_id,

               # Edges
               KEGGX_species                 = set (species),
               KEGGX_pathway                 = set ()
            )

         else:
            keggx = db.KEGGX[temp2.biosystem_ncbi_gene_id]

            check.setValue (keggx, 'KEGGX_type', temp2.type_of_gene)
            check.setValue (keggx, 'KEGGX_description', temp2.gene_description)
            check.setValue (keggx, 'KEGGX_symbol', temp2.gene_symbol)

            if temp2.species: keggx.KEGGX_species.add (temp2.species)


         # Species
         if temp2.species and temp2.species not in db.SP:
            db.SP[temp2.species] = Arguments (
               SP_id = temp2.species
            )
