
##---------------------------Imports-----------------------------------------------##
import os, sys

import check

from Arguments import Arguments



##---------------------------Start load--------------------------------------------##
def load (filename, db):
   with open (filename, 'r') as file:
      header = file.readline ().strip ().split ('\t')

      for line in file:
         tline = line.strip ()
         if len (tline) == 0: continue

         temp1 = tline.split ('\t')
         temp2 = Arguments ()

         # Glue header with values
         for h, t in zip (header, temp1): temp2[h] = t


         # Check consistency
         if temp2.biosystem_ncbi_gene_id not in db.KEGGX or temp2.bsid not in db.PWbs or db.PWbs[temp2.bsid].PW_id not in db.PW:
            raise Exception ("Missing Nodes for line '%s' -> '%s'" % (temp2.entry_stable_id, temp2.bsid) )


         # Edge
         db.KEGGX[temp2.biosystem_ncbi_gene_id].KEGGX_pathway.add (db.PWbs[temp2.bsid].PW_id)
