
##---------------------------Imports-----------------------------------------------##
import os, sys

import check

from Arguments import Arguments



##---------------------------Start load--------------------------------------------##
def load (filename, db):
   with open (filename, 'r') as file:
      header = file.readline ().strip ().split ('\t')

      for line in file:
         tline = line.strip ()
         if len (tline) == 0: continue

         temp1 = tline.split ('\t')
         temp2 = Arguments ()

         # Glue header with values
         for h, t in zip (header, temp1): temp2[h] = t


         # Check consistency
         if temp2.entry_stable_id not in db.AF:
            print ("Warning: Missing Node '%s'" % temp2.entry_stable_id, file = sys.stderr)
            continue


         af = db.AF[temp2.entry_stable_id]

         synonyms = temp2.synonyms.split ('||')

         if '' in synonyms:
            print ("Warning: Empty Synonym for Node '%s'" % temp2.entry_stable_id, file = sys.stderr)
            synonyms.remove ('')

         try: synonyms.remove (af.AF_name)
         except: pass

         af.AF_synonyms.update (synonyms)
