
##---------------------------Imports-----------------------------------------------##
import os, sys

import check

from Arguments import Arguments



##---------------------------Start load--------------------------------------------##
def load (filename, db):
   with open (filename, 'r') as file:
      header = file.readline ().strip ().split ('\t')

      for line in file:
         tline = line.strip ()
         if len (tline) == 0: continue

         temp1 = tline.split ('\t')
         temp2 = Arguments ()

         # Glue header with values
         for h, t in zip (header, temp1): temp2[h] = t


         # Check consistency
         if temp2.entry_stable_id not in db.AF: raise Exception ("Missing Node '%s'" % temp2.entry_stable_id)
         if temp2.observation_stable_id not in db.OB: raise Exception ("Missing Node '%s'" % temp2.observation_stable_id)


         ob = db.OB[temp2.observation_stable_id]

         if temp2.observation_type == "phenotype_2": temp2.observation_type = "lifespan"

         check.setValue (ob, 'OB_type', temp2.observation_type)

         ob.OB_ageing_factors.add (temp2.entry_stable_id)
