
##---------------------------Imports-----------------------------------------------##
import os, sys

import check

from Arguments import Arguments



##---------------------------Start load--------------------------------------------##
def load (filename, db):
   with open (filename, 'r') as file:
      header = file.readline ().strip ().split ('\t')

      for line in file:
         tline = line.strip ()
         if len (tline) == 0: continue

         temp1 = tline.split ('\t')
         temp2 = Arguments ()

         # Glue header with values
         for h, t in zip (header, temp1): temp2[h] = t


         temp2.base_entry_stable_ids = temp2.base_entry_stable_ids.split ('||')

         # Check consistency (there is no consistency)
         pass


         # AgeingFactor
         if temp2.entry_stable_id not in db.AF:
            species = [temp2.species] if temp2.species else []

            db.AF[temp2.entry_stable_id] = Arguments (
               AF_id                      = temp2.entry_stable_id,
               AF_type                    = 'gene',
               AF_name                    = temp2.entry_name,
               AF_synonyms                = set (),
               AF_ncbi_gene_id            = temp2.ncbi_gene_id,
               AF_lifespan_data_available = False,
               AF_putative                = False,

               # Edges
               AF_species                 = set (species)
            )

         else:
            af = db.AF[temp2.entry_stable_id]

            check.setValue (af, 'AF_name', temp2.entry_name)
            check.setValue (af, 'AF_ncbi_gene_id', temp2.ncbi_gene_id)

            if temp2.species: af.AF_species.add (temp2.species)


         if not all ([baf in db.AF for baf in temp2.base_entry_stable_ids]):
            raise Exception ("Missing Base Node for line '%s' -> %s' -> '%s'" % (str(temp2.base_entry_stable_ids), temp2.observation_stable_id, temp2.entry_stable_id) )


         # Observation
         if temp2.observation_stable_id not in db.OB:
            species = [temp2.species] if temp2.species else []

            db.OB[temp2.observation_stable_id] = Arguments (
               OB_id                          = temp2.observation_stable_id,
               #OB_lifespan_effect_significant = temp2.lifespan_effect_significant,
               #OB_lifespan_change             = temp2.lifespan_change,
               #OB_lifespan_measure            = temp2.lifespan_measure,
               OB_homology_database           = 'HomoloGene',   # Hack, is normally dependent of homologene_id
               OB_homology_group_id           = temp2.homologene_id,

               # Edges
               OB_species                     = set (species),
               OB_ageing_factors              = set ([temp2.entry_stable_id]),
               OB_base_ageing_factors         = set (temp2.base_entry_stable_ids),
               OB_allele_types                = set ()
            )

         else:
            ob = db.OB[temp2.observation_stable_id]

            check.setValue (ob, 'OB_homology_database', 'HomoloGene')
            check.setValue (ob, 'OB_homology_group_id', temp2.homologene_id)

            if temp2.species: ob.OB_species.add (temp2.species)
            ob.OB_base_ageing_factors.update (temp2.base_entry_stable_ids)
