
##---------------------------Imports-----------------------------------------------##
import os, sys

from Arguments import Arguments



##---------------------------Start load--------------------------------------------##
def load (filename, db):
   with open (filename, 'r') as file:
      header = file.readline ().strip ().split ('\t')

      for line in file:
         tline = line.strip ()
         if len (tline) == 0: continue

         temp1 = tline.split ('\t')
         temp2 = Arguments ()

         # Glue header with values
         for h, t in zip (header, temp1): temp2[h] = t

         temp2.observation_stable_id = 'OB_%06d' % int (temp2.observation_id)


         # Check consistency
         if temp2.entry_stable_id not in db.AF or temp2.observation_stable_id not in db.OB:
            raise Exception ("Missing Nodes for line '%s' -- '%s'" % (temp2.observation_stable_id, temp2.entry_stable_id) )


         if temp2.entry_stable_id not in db.OB[temp2.observation_stable_id].OB_ageing_factors:
            raise Exception ()


         if temp2.homology_analysis_status == 'added' and db.AF[temp2.entry_stable_id].AF_lifespan_data_available != False:
            print ("Warning: '%s' mismatch between homology_analysis_status and AF_lifespan_data_available" % temp2.entry_stable_id, file = sys.stderr)
         if temp2.homology_analysis_status == 'not added' and db.AF[temp2.entry_stable_id].AF_lifespan_data_available != True:
            print ("Warning: '%s' mismatch between homology_analysis_status and AF_lifespan_data_available" % temp2.entry_stable_id, file = sys.stderr)


         if temp2.homology_analysis_status == 'added':
            db.AF[temp2.entry_stable_id].AF_putative = True
         elif temp2.homology_analysis_status == 'not added':
            db.AF[temp2.entry_stable_id].AF_putative = False
         else:
            raise Exception ("Unknown homology analysis status '%s'" % temp2.homology_analysis_status)
