
##---------------------------Imports-----------------------------------------------##
import os, sys

import check

from Arguments import Arguments



##---------------------------Start load--------------------------------------------##
def load (filename, db):
   with open (filename, 'r') as file:
      header = file.readline ().strip ().split ('\t')

      for i, line in enumerate (file):
         tline = line.strip ()
         if len (tline) == 0: continue

         temp1 = tline.split ('\t')
         temp2 = Arguments ()

         # Glue header with values
         for h, t in zip (header, temp1): temp2[h] = t


         # Check consistency
         if temp2.observation_stable_id not in db.OB: raise Exception ("Missing Node '%s'" % temp2.observation_stable_id)


         # Citation
         if 'pubmed_id' in temp2:
            CT_id = 'pubmed_' + temp2.pubmed_id

            if CT_id not in db.CT:
               db.CT[CT_id] = Arguments (
                  CT_id       = CT_id,
                  CT_database = 'PubMed',
                  CT_pub_id   = temp2.pubmed_id,

                  # Edges
                  CT_observations = set ([temp2.observation_stable_id])
               )
            else:
               ct = db.CT[CT_id]

               check.setValue (ct, 'CT_database', 'PubMed')
               check.setValue (ct, 'CT_pub_id', temp2.pubmed_id)

               ct.CT_observations.add (temp2.observation_stable_id)

         else:
            raise Exception ("Publisher unknown:\n" % temp2.__str__() )
