
##---------------------------Imports-----------------------------------------------##
import os, sys

import check

from Arguments import Arguments



##---------------------------Start load--------------------------------------------##
def load (filename, db):
   with open (filename, 'r') as file:
      header = file.readline ().strip ().split ('\t')

      for line in file:
         tline = line.strip ()
         if len (tline) == 0: continue

         temp1 = tline.split ('\t')
         temp2 = Arguments ()

         # Glue header with values
         for h, t in zip (header, temp1): temp2[h] = t


         # GeneOntologyTerm
         if temp2.go_id not in db.GO:
            species = [temp2.species] if temp2.species else []

            db.GO[temp2.go_id] = Arguments (
               GO_id                      = temp2.go_id,
               GO_term                    = temp2.go_term,
               GO_category                = temp2.go_category,
               GO_evidence                = set ([temp2.evidence]),

               # Edges
               GO_species                 = set (species),
               GO_ageing_factors          = [{'AF_id': temp2.entry_stable_id, 'GO_qualifier': temp2.qualifier}]
            )

         else:
            go = db.GO[temp2.go_id]

            check.setValue (go, 'GO_term', temp2.go_term)
            check.setValue (go, 'GO_category', temp2.go_category)

            go.GO_evidence.add (temp2.evidence)
            if temp2.species: go.GO_species.add (temp2.species)
            go.GO_ageing_factors.append ({'AF_id': temp2.entry_stable_id, 'GO_qualifier': temp2.qualifier})


         # AgeingFactor
         if temp2.entry_stable_id not in db.AF:
            #raise Exception ("AgeingFactor '%s' don't exist" % temp2.entry_stable_id)
            species = [temp2.species] if temp2.species else []

            db.AF[temp2.entry_stable_id] = Arguments (
               AF_id                      = temp2.entry_stable_id,
               AF_type                    = 'gene',
               AF_name                    = temp2.gene_symbol,
               AF_synonyms                = set (),
               AF_ncbi_gene_id            = temp2.ncbi_gene_id,
               AF_lifespan_data_available = False,
               AF_putative                = False,

               # Edges
               AF_species                 = set (species)
            )

         else:
            af = db.AF[temp2.entry_stable_id]

            check.setValue (af, 'AF_ncbi_gene_id', temp2.ncbi_gene_id)
            check.setValue (af, 'AF_name', temp2.gene_symbol)

            if temp2.species: af.AF_species.add (temp2.species)


         # Species
         if temp2.species and temp2.species not in db.SP:
            db.SP[temp2.species] = Arguments (
               SP_id = temp2.species,
            )
