
##---------------------------Imports-----------------------------------------------##
import os, sys

import check

from Arguments import Arguments



##---------------------------Start load--------------------------------------------##
def load (filename, db):
   with open (filename, 'r') as file:
      header = file.readline ().strip ().split ('\t')

      for line in file:
         tline = line.strip ()
         if len (tline) == 0: continue

         temp1 = tline.split ('\t')
         temp2 = Arguments ()

         # Glue header with values
         for h, t in zip (header, temp1): temp2[h] = t


         # Pathway
         if 'biosystem_source_db_accession' in temp2:
            PW_id = 'BS_' + temp2.biosystem_source_db_accession

            if PW_id not in db.PW:
               db.PW[PW_id] = pw = Arguments (
                  PW_id                      = PW_id,
                  PW_type                    = temp2.biosystem_type,
                  PW_name                    = temp2.biosystem_name,
                  PW_description             = temp2 ('biosystem_description', missing_ok = True, default = None),
                  PW_scope                   = temp2.biosystem_taxonomic_scope,
                  PW_source                  = temp2.biosystem_source_db,
                  PW_source_id               = temp2.biosystem_source_db_accession,
                  PW_ncbi_tax_id             = temp2 ('ncbi_taxid', missing_ok = True, default = None),

                  # Edges
                  PW_ageing_factors          = set ()
               )

               #if 'biosystem_description' in temp2: pw.PW_description = temp2.biosystem_description
               #if 'ncbi_taxid' in temp2: pw.PW_ncbi_tax_id = temp2.ncbi_taxid

            else:
               pw = db.PW[PW_id]

               check.setValue (pw, 'PW_type', temp2.biosystem_type)
               check.setValue (pw, 'PW_name', temp2.biosystem_name)
               check.setValue (pw, 'PW_scope', temp2.biosystem_taxonomic_scope)
               check.setValue (pw, 'PW_source', temp2.biosystem_source_db)
               check.setValue (pw, 'PW_source_id', temp2.biosystem_source_db_accession)

               if 'biosystem_description' in temp2: check.setValue (pw, 'PW_description', temp2.biosystem_description)
               if 'ncbi_taxid' in temp2: check.setValue (pw, 'PW_ncbi_tax_id', temp2.ncbi_taxid)


            # Mapping from bsid to PW_id
            if temp2.bsid not in db.PWbs:
               db.PWbs[temp2.bsid] = Arguments (
                  PW_id = PW_id
               )
            elif db.PWbs[temp2.bsid].PW_id != PW_id:
               raise Exception ("Line mismatch")

         else:
            raise Exception ("Pathway unknown:\n" % temp2.__str__() )
