BEGIN {
    %t2n = (
        "ag" => "AgeingFactor",
        "ob" => "Observation",
        "al" => "AlleleType",
        "sp" => "Species",
        "ci" => "Citation",
        "go" => "GO"
    );
    %info = (
        #"un" => { "color" => "rgb(60,60,60)",    "val" => "15" },
        #"ag" => { "color" => "rgb(255,0,255)",   "val" => "25" },
        #"ob" => { "color" => "rgb(154,205,50)",  "val" => "15" },
        #"al" => { "color" => "rgb(244,164,96)",  "val" => "18" },
        #"ci" => { "color" => "rgb(210,180,140)", "val" => "17" },
        #"sp" => { "color" => "rgb(240,240,65)",  "val" => "35" },
        #"go" => { "color" => "rgb(135,206,250)", "val" => "20" }
        "un" => { "color" => "#3C3C3C", "val" => "15" },
        "ag" => { "color" => "#FF00FF", "val" => "25" },
        "ob" => { "color" => "#9ACD32", "val" => "15" },
        "al" => { "color" => "#F4A460", "val" => "18" },
        "ci" => { "color" => "#D2B48C", "val" => "17" },
        "sp" => { "color" => "#F0F041", "val" => "35" },
        "go" => { "color" => "#87CEFA", "val" => "20" }
    );
}
chomp($_);
@t1 = split( /\t/, $_, -1 );
if ( $#t1 < 1 ) { next }

$n1 = $t1[0];
$n2 = $t1[1];
if ( $n1 =~ /^"(ag|ob|al|ci|sp|go)/ ) { $type1 = $1 }
if ( $n2 =~ /^"(ag|ob|al|ci|sp|go)/ ) { $type2 = $1 }
@att = ( "\"id\":$n1", "\"type\":\"$t2n{$type1}\"" );

foreach $att ( sort keys %{ $info{$type1} } ) {
    push( @att, "\"$att\":\"$info{$type1}->{$att}\"" );
}
$nodes{$n1} = "{" . join( ",", @att ) . "}";
@att = ( "\"id\":$n2", "\"type\":\"$t2n{$type2}\"" );
foreach $att ( sort keys %{ $info{$type2} } ) {
    push( @att, "\"$att\":\"$info{$type2}->{$att}\"" );
}
$nodes{$n2} = "{" . join( ",", @att ) . "}";
$lc = "rgb(60,60,60,0.4)";
if    ( $type1 eq "ob" || $type2 eq "ob" ) { $lc = $info{"ob"}->{"color"}; }
elsif ( $type1 eq "al" || $type2 eq "al" ) { $lc = $info{"al"}->{"color"}; }
elsif ( $type1 eq "sp" || $type2 eq "sp" ) { $lc = $info{"sp"}->{"color"}; }
elsif ( $type1 eq "ci" || $type2 eq "ci" ) { $lc = $info{"ci"}->{"color"}; }
elsif ( $type1 eq "go" || $type2 eq "go" ) { $lc = $info{"go"}->{"color"}; }
$link = "{\"source\":$n1,\"target\":$n2,\"color\":\"$lc\"}";
push( @links, $link );

END {
    @nodes = ();
    foreach $node ( sort keys %nodes ) {
        push( @nodes, $nodes{$node} );
    }
    print "{\"nodes\":[\n", join( ",\n", @nodes ), "],\n\"links\":[",
      join( ",\n", @links ), "]}\n";
}
