#!/usr/bin/env python3

import sys, os
import re

from neo4j.v1 import GraphDatabase


path = os.path.dirname (os.path.realpath (__file__) )
sys.path.insert (0, path)

import process

from Arguments import Arguments


config = Arguments ()
config.load('settings.ini')
db = GraphDatabase.driver(config.url, auth = config["user", "password"])


with open (sys.argv[1], 'r') as file:
   for i, line in enumerate (file):
      try:
         if not line or len (line) < 5: continue
         print ("\r%d" % i, end="")

         c = Arguments ()

         A, B = re.findall ('^"(.*)"\s*"(.*)"\n?$', line)[0]

         c.A_type, c.A_id = A.split ('||', 1)
         c.B_type, c.B_id = B.split ('||', 1)

         c.A_type      = process.parseTypes (c.A_type)
         c.B_type      = process.parseTypes (c.B_type)
         c.connectorAB = process.getConnector (c.A_type, c.B_type)
         c.connectorBA = process.getConnector (c.B_type, c.A_type)

         #print ("%s-%s -> %s-%s" % (c.A_id, c.A_type, c.B_id, c.B_type) )

         with db.session() as session:
            session.run (process.parseCypher ('connectNodes', c) )
            #process.call (session, 'commands/connectNodes', c)
      except:
         print ("--- Error in file %s:%d" % sys.argv[1], i)
