
import os, sys
import re


BASE_DIR = os.path.dirname (os.path.dirname (os.path.abspath (__file__) ) )


TYPES = {
   'ageingFactorId': 'AgeingFactor',
   'species': 'Species',
   'observationId': 'Observation'
}

CONNECTORS = {
   ('AgeingFactor', 'Species'): 'afTOsp',
   ('Species', 'AgeingFactor'): 'spTOaf'
}



def parseTypes (type):
   if type in TYPES:
      return TYPES[type]
   else:
      return type



def getConnector (type1, type2):
   if (type1, type2) in CONNECTORS:
      return CONNECTORS[(type1, type2)]
   else:
      return 'unknown'



def parseCypher (filename, config):
   if not os.path.isfile (filename):
      filename = os.path.join (BASE_DIR, "Cypher", filename + '.cypher')
   if not os.path.isfile (filename):
      raise Exception ("File not found '%s'" % (filename) )

   with open (filename, 'r') as file:
      cypher = file.read ()
      #for line in file:
      #   if line.lstrip()[0] != '#':
      #      cypher += line

      def replace (m):
         key = m.group(1)
         return config[key]

      return re.sub ('\$\{([a-zA-Z0-9_-]+)\}', replace, cypher)



def parseCyphers (filenames, config):
   if type (filenames)  == str:
      filenames = [filenames]

   res = ""

   for filename in filenames:
      res += parseCypher (filename, config)
      if res[-1] != '\n': res += '\n'

   return res
