
//---------------------------Start export_XGMML-----------------------------------------//
function export_XGMML (nodes, links) {
   var nodeKey = { AgeingFactor: "ageingFactorId", AlleleType: "alleleType", Citation: "C", GeneOntologyTerm: "???", KEGGPathwayExtraGenes: "???", Observation: "O", Pathway: "???", Species: "???" };
   var nodeTypeId = { AgeingFactor: "F", AlleleType: "Al", Citation: "C", GeneOntologyTerm: "???", KEGGPathwayExtraGenes: "???", Observation: "O", Pathway: "???", Species: "???" };
   var nodeSubTypeId = { AgeingFactor: "AF_", AlleleType: "ALT_ALT", Citation: "CIT_CIT", GeneOntologyTerm: "???", KEGGPathwayExtraGenes: "???", Observation: "OB_", Pathway: "???", Species: "???" };
   var doc = document.implementation.createDocument (null, "graph");
   var graph = doc.documentElement;

   // Root attributes
   graph.setAttribute ("label", "TOR1_S.cerevisiae_direct_ALT_CIT_HOM");
   graph.setAttribute ("xmlns:dc", "http://purl.org/dc/elements/1.1/");
   graph.setAttribute ("xmlns:xlink", "http://www.w3.org/1999/xlink");
   graph.setAttribute ("xmlns:rdf", "http://www.w3.org/1999/02/22-rdf-syntax-ns#");
   graph.setAttribute ("xmlns:cy", "http://www.cytoscape.org");
   graph.setAttribute ("xmlns", "http://www.cs.rpi.edu/XGMML");
   graph.setAttribute ("directed", "0");


   function addAttr (elem, name, type, value) {
      var att = doc.createElement ("att");

      att.setAttribute ("name", name);
      att.setAttribute ("type", type);
      att.setAttribute ("value", value);

      elem.appendChild (att);
   }//end Fct


   nodes.forEach ( (e,p) => {
      var elem = doc.createElement ("node");

      elem.setAttribute ("label", e.id);
      //elem.setAttribute ("id", e.id);   //TODO what should I set here?

      addAttr (elem, nodeKey[e.type], "string", e.id);
      addAttr (elem, "infoKey", "string", nodeKey[e.type]);
      addAttr (elem, "nodeId", "string", e.id);
      addAttr (elem, "nodeKey", "string", nodeKey[e.type] + "||" + e.id);
      addAttr (elem, "nodeNumber", "string", "" + p);
      addAttr (elem, "nodeTypeId", "string", nodeTypeId[e.type]);
      addAttr (elem, "subnetworkNumber", "string", "1");
      addAttr (elem, "temperature", "string", "0.0");
      addAttr (elem, "x", "string", e.x);
      addAttr (elem, "y", "string", e.y);
      addAttr (elem, "z", "string", e.z);


      switch (e.type) {
      case "AgeingFactor": {
         var species = {}; e.species.forEach (e => {species[e] = true});

         addAttr (elem, "ageingFactorName", "string", e.name);   // <att name="ageingFactorName" type="string" value="FOB1"/>
         addAttr (elem, "ageingFactorType", "string", e.subtype);   // <att name="ageingFactorType" type="string" value="gene"/>
         //addAttr (elem, "baseEntryStableIds", "string", e.???);   // <att name="baseEntryStableIds" type="string" value="AF_000303"/>
         addAttr (elem, "homologyAnalysisStatus", "string", e.putative ? "added" : "not added");   // <att name="homologyAnalysisStatus" type="string" value="not added"/>
         //addAttr (elem, "labelCustom", "string", e.???);   // <att name="labelCustom" type="string" value="Gene: FOB1, Saccharomyces cerevisiae|(AF_000303)"/>
         //addAttr (elem, "labelLong", "string", e.???);   // <att name="labelLong" type="string" value="Gene: FOB1, S. cerevisiae|(AF_000303, #1)"/>
         addAttr (elem, "labelShort", "string", e.name);   // <att name="labelShort" type="string" value="FOB1"/>
         addAttr (elem, "lifespanDataAvailable", "string", e.lifespanDataAvailable);   // <att name="lifespanDataAvailable" type="string" value="true"/>
         addAttr (elem, "ncbiGeneId", "string", e.ncbiGeneID);   // <att name="ncbiGeneId" type="string" value="851688"/>
         addAttr (elem, "nodeSubType", "string", e.subtype);   // <att name="nodeSubType" type="string" value="gene"/>
         //addAttr (elem, "nodeSubTypeId", "string", e.???);   // <att name="nodeSubTypeId" type="string" value="AF_GEN"/>
         addAttr (elem, "nodeType", "string", "ageingFactor");   // <att name="nodeType" type="string" value="ageingFactor"/>
         addAttr (elem, "species", "string", species);   // <att name="species" type="string" value="{'Saccharomyces cerevisiae'  :  true}"/>
         //addAttr (elem, "speciesShortcut", "string", e.???);   // <att name="speciesShortcut" type="string" value="S. cerevisiae"/>
         addAttr (elem, "subTypeInfoKey", "string", "ageingFactorType");   // <att name="subTypeInfoKey" type="string" value="ageingFactorType"/>
         addAttr (elem, "subTypeInfoKeys", "string", "ageingFactorType");   // <att name="subTypeInfoKeys" type="string" value="ageingFactorType"/>
      } break;
      case "AlleleType": {
      } break;
      case "Citation": {
      } break;
      case "GeneOntologyTerm": {
      } break;
      case "KEGGPathwayExtraGenes": {
      } break;
      case "Observation": {
      } break;
      case "Pathway": {
      } break;
      case "Species": {
      } break;
      };//end switch

      graph.appendChild (elem);
   });//end for


   links.forEach ( (e,p) => {
      var elem = doc.createElement ("edge");
      var pair = {'source': {}, 'target': {} };

      ['source', 'target'].forEach (k => {
         pair[k].nodeKey = nodeKey[e[k].type] + "||" + e[k].id;
         pair[k].nodeSubTypeId = nodeSubTypeId[e[k].type];
         pair[k].nodeTypeId = nodeTypeId[e[k].type];

         switch (e[k].type) {
         case "AgeingFactor": {
            if (e[k].subtype == "gene") pair[k].nodeSubTypeId = "AF_GEN";
            else if (e[k].subtype == "compound") pair[k].nodeSubTypeId = "AF_???";
            else if (e[k].subtype == "other_factor") pair[k].nodeSubTypeId = "AF_???";
         } break;
         case "AlleleType": {
         } break;
         case "GeneOntologyTerm": {
         } break;
         case "KEGGPathwayExtraGenes": {
         } break;
         case "Observation": {
            if (e[k].subtype == "lifespan") pair[k].nodeSubTypeId += "INC";
            else if (e[k].subtype == "lifespan") pair[k].nodeSubTypeId += "DEC";
            else if (e[k].subtype == "homology_analysis") pair[k].nodeSubTypeId += "HOM";
         } break;
         case "Pathway": {
         } break;
         case "Species": {
         } break;
         };//end switch
      });//end for

      elem.setAttribute ("label", pair.source.nodeKey + "||" + e.source.id + "%%" + pair.target.nodeKey + "||" + e.target.id);
      elem.setAttribute ("source", e.source.id);
      elem.setAttribute ("target", e.target.id);

      addAttr (elem, "edgeNumber", "string", "" + p);   // <att name="edgeNumber" type="string" value="77"/>
      addAttr (elem, "nodeKey1", "string", pair.source.nodeKey);   // <att name="nodeKey1" type="string" value="observationId||OB_009244"/>
      addAttr (elem, "nodeKey2", "string", pair.target.nodeKey);   // <att name="nodeKey2" type="string" value="ageingFactorId||AF_016973"/>
      // addAttr (elem, "nodeNumber1", "string", pair.source.???);   // <att name="nodeNumber1" type="string" value="27"/>
      // addAttr (elem, "nodeNumber2", "string", pair.target.???);   // <att name="nodeNumber2" type="string" value="40"/>
      addAttr (elem, "nodeSubTypeId1", "string", pair.source.nodeSubTypeId);   // <att name="nodeSubTypeId1" type="string" value="OB_HOM"/>
      addAttr (elem, "nodeSubTypeId2", "string", pair.target.nodeSubTypeId);   // <att name="nodeSubTypeId2" type="string" value="AF_GEN"/>
      addAttr (elem, "nodeTypeId1", "string", pair.source.nodeTypeId);   // <att name="nodeTypeId1" type="string" value="O"/>
      addAttr (elem, "nodeTypeId2", "string", pair.target.nodeTypeId);   // <att name="nodeTypeId2" type="string" value="F"/>
      addAttr (elem, "subnetworkNumber", "string", "1");   // <att name="subnetworkNumber" type="string" value="1"/>
      addAttr (elem, "temperature", "string", "0.0");   // <att name="temperature" type="string" value="0.0"/>

      graph.appendChild (elem);
   });//end for


   return doc;
}//end Fct
