
//---------------------------Class Hover------------------------------------------------//
class Hover {
   // Restore constructor
   constructor (memory, node) {
      this.memory = memory;
      this.node = node;

      this.lines = {id: true, name: true, type: true, subtype: true, ncbigeneid: true, putative: true, lifespan: true, homology: true, database: true, evidence: true, description: true, scope: true, source: true, species: true, degree: true};

      (this.selector = node.appendChild (document.createElement ("div") ) ).className = "selector";
      (this.hover = node.appendChild (document.createElement ("div") ) ).className = "hover";
      (this.legend = node.appendChild (document.createElement ("div") ) ).className = "legend";
      (this.foobar = node.appendChild (document.createElement ("div") ) ).className = "foobar";

      this.showLegend ();
      this.showSelector ();
   }//end Constructor


   //------------------------Start hide-------------------------------------------------//
   hide () {
      this.hover.style.setProperty ("display", "none");
   }//end Fct


   //------------------------Start show-------------------------------------------------//
   show (node, prevNode) {
      try {
         if (node == null) {
            this.hover.style.setProperty ("display", "none");    // Hide

         } else {
            var addLine = (label, msg) => {
               var li = document.createElement ("li");
               if (msg === undefined) msg = this.memory.menu.na;
               li.innerHTML = "<label>" + label + "</label>: " + "<span>" + msg + "</span>";
               ul.appendChild (li);
            };//end Lambda

            var ul = document.createElement ("ul");

            if (node.type == "AgeingFactor") this.fillAgeingFactor (node, addLine);
            else if (node.type == "AlleleType") this.fillAlleleType (node, addLine);
            else if (node.type == "Citation") this.fillCitation (node, addLine);
            else if (node.type == "GeneOntologyTerm") this.fillGeneOntologyTerm (node, addLine);
            else if (node.type == "KEGGPathwayExtraGenes") this.fillKEGGPathwayExtraGenes (node, addLine);
            else if (node.type == "Observation") this.fillObservation (node, addLine);
            else if (node.type == "Pathway") this.fillPathway (node, addLine);
            else if (node.type == "Species") this.fillSpecies (node, addLine);
            else return;

            if (node.hasOwnProperty ("color") )
               this.hover.style.setProperty ("border-color", node.color);   // Coloring
            else
               this.hover.style.removeProperty ("border-color");   // Un-Coloring

            while (this.hover.firstChild)
               this.hover.removeChild (this.hover.firstChild);

            this.hover.appendChild (ul);

            this.hover.style.setProperty ("display", "block");   // Show
         }
      } catch (e) { console.error (e); }
   }//end Fct


   //------------------------Start showLegend-------------------------------------------//
   showLegend () {
      var div = document.createElement ("div");
      var ul = document.createElement ("ul");
      var _this = this;
      var rows = [];
      ul.addEventListener ("click", event => {
         var key = (event.target.nodeName == "LI") ? event.target.getAttribute("node-key") : event.target.parentNode.getAttribute("node-key");
         if (key) {
            this.memory.graph.toggleVisibility(key);
            rows.forEach (node => {
               var key = node.parentNode.getAttribute ("node-key");
               if (this.memory.graph.active[key] === false)
                  node.style.setProperty ("opacity", "0");
               else
                  node.style.removeProperty ("opacity");
            })
         }
      });

      function addLine (label, color, key) {
         var li = ul.appendChild (document.createElement ("li") );
         var cnode = li.appendChild (document.createElement ("div") );
         var lnode = li.appendChild (document.createElement ("label") );
         li.setAttribute ("node-key", key);
         lnode.textContent = label;
         cnode.style.cssText = "width: 10px; height: 10px; margin: 3px 6px;";
         cnode.style.setProperty ("background-color", color);
         if (_this.memory.graph.active[key] === false)
            cnode.style.setProperty ("opacity", "0");
         rows.push (cnode);
      }//end Lambda

      addLine ("AgeingFactor Gene", this.memory.graph.colors.AgeingFactor_gene, "AgeingFactor");
      addLine ("AgeingFactor Compound", this.memory.graph.colors.AgeingFactor_compound, "AgeingFactor");
      addLine ("AgeingFactor Other factor", this.memory.graph.colors.AgeingFactor_other_factor, "AgeingFactor");

      addLine ("AlleleType", this.memory.graph.colors.AlleleType, "AlleleType");
      addLine ("Citation", this.memory.graph.colors.Citation, "Citation");

      addLine ("GeneOntologyTerm Component", this.memory.graph.colors.GeneOntologyTerm_Component, "GeneOntologyTerm");
      addLine ("GeneOntologyTerm Function", this.memory.graph.colors.GeneOntologyTerm_Function, "GeneOntologyTerm");
      addLine ("GeneOntologyTerm Process", this.memory.graph.colors.GeneOntologyTerm_Process, "GeneOntologyTerm");

      addLine ("KEGGPathwayExtraGenes", this.memory.graph.colors.KEGGPathwayExtraGenes, "KEGGPathwayExtraGenes");

      addLine ("Observation", this.memory.graph.colors.Observation, "Observation");
      addLine ("Observation Lifespan", this.memory.graph.colors.Observation_lifespan, "Observation");
      addLine ("Observation Lifespan increase", this.memory.graph.colors.Observation_inc, "Observation");
      addLine ("Observation Lifespan decrease", this.memory.graph.colors.Observation_dec, "Observation");
      addLine ("Observation Homology analysis", this.memory.graph.colors.Observation_homology_analysis, "Observation");

      addLine ("Pathway", this.memory.graph.colors.Pathway, "Pathway");
      addLine ("Species", this.memory.graph.colors.Species, "Species");
      addLine ("Genes of Interest", this.memory.graph.colors.AgeingFactor_gene, "GOI");
      addLine ("Undefined", this.memory.graph.colors.default, "default");


      while (this.legend.firstChild)
         this.legend.removeChild (this.legend.firstChild);

      this.legend.appendChild (div).appendChild (ul);

      this.legend.style.setProperty ("display", "block");   // Show
   }//end Fct


   //------------------------Start hideLegend-------------------------------------------//
   hideLegend () {
      this.legend.style.removeProperty ("display");
   }//end Fct


   //------------------------Start showSelector-----------------------------------------//
   showSelector () {
      var div = document.createElement ("div");
      var ul = document.createElement ("ul");
      var li;
      var rows = [];
      div.addEventListener ("mouseover", this.hide.bind (this) );
      ul.addEventListener ("click", event => {
         var li = (event.target.nodeName == "LI") ? event.target : event.target.parentNode;

         if (li.children[0].getAttribute ("x-active") == "true") {
            li.children[0].style.setProperty ("opacity", "0");
            li.children[0].setAttribute ("x-active", "false");
            li.dispatchEvent (new Event ("off") );
         } else {
            li.children[0].style.removeProperty ("opacity");
            li.children[0].setAttribute ("x-active", "true");
            li.dispatchEvent (new Event ("on") );
         }

         //li.children[0].style.removeProperty ("opacity");
         //setTimeout ( () => li.children[0].style.setProperty ("opacity", "0"), 1000);
      });

      function addLine (label, color, on, off) {
         li = ul.appendChild (document.createElement ("li") );
         var cnode = li.appendChild (document.createElement ("div") );
         var lnode = li.appendChild (document.createElement ("label") );
         lnode.textContent = label;
         cnode.style.cssText = "width: 10px; height: 10px; margin: 3px 6px; opacity: 0;";
         cnode.style.setProperty ("background-color", color);
         rows.push (cnode);
         li.addEventListener ("on", on);
         li.addEventListener ("off", off);
      }//end Lambda

      addLine ("Select all nodes", this.memory.graph.colors.AgeingFactor_gene, () => this.memory.select.selected = this.memory.graph.data.nodes, () => this.memory.select.selected = []);
      addLine ("Select AgeingFactors", this.memory.graph.colors.AgeingFactor_gene, () => this.memory.select.addNodes (this.memory.select.searchType ("type", "AgeingFactor") ), () => this.memory.select.removeNodes (this.memory.select.searchType ("type", "AgeingFactor") ) );
      addLine ("Select Observations", this.memory.graph.colors.Observation, () => this.memory.select.addNodes (this.memory.select.searchType ("type", "Observation") ), () => this.memory.select.removeNodes (this.memory.select.searchType ("type", "Observation") ) );
      addLine ("Select Labeled Nodes", this.memory.graph.colors.Observation, () => this.memory.select.selected = this.memory.select.searchType ("labeled"), () => this.memory.select.removeNodes (this.memory.select.searchType ("labeled") ) );
      addLine ("Resolve AgeingFactors", this.memory.graph.colors.AgeingFactor_gene, () => this.memory.graph.neighborLSChange (), () => this.memory.graph.update () );
      addLine ("Resize by degree", this.memory.graph.colors.AgeingFactor_gene, () => this.memory.graph.data.nodes.forEach (node => this.memory.graph.resizeNode (node, node.links.length * 0.2) ), () => this.memory.graph.data.nodes.forEach (node => this.memory.graph.resizeNode (node, "reset") ) );
      addLine ("Resize by lifespan", this.memory.graph.colors.Observation_lifespan, () => this.memory.graph.resizeByLO (undefined, 1), () => this.memory.graph.resizeByLO () );
      addLine ("Label Observations", this.memory.graph.colors.Observation, () => this.memory.select.searchType ("type", "Observation").forEach (node => this.memory.graph.addNodeLabel (node) ), () => this.memory.select.searchType ("type", "Observation").forEach (node => this.memory.graph.removeNodeLabel (node) ) );
      addLine ("Paper Mode", this.memory.graph.colors.bg, () => this.memory.graph.renderer.setClearColor (new THREE.Color (this.memory.graph.colors.bg = "#FFFFFF") ), () => this.memory.graph.renderer.setClearColor (new THREE.Color (this.memory.graph.colors.bg = "#000011") ) );


      while (this.selector.firstChild)
         this.selector.removeChild (this.selector.firstChild);

      this.selector.appendChild (div).appendChild (ul);

      this.selector.style.setProperty ("display", "block");   // Show
   }//end Fct


   //------------------------Start hideSelector-----------------------------------------//
   hideSelector () {
      this.selector.style.removeProperty ("display");
   }//end Fct


   //------------------------Start fillAgeingFactor-------------------------------------//
   fillAgeingFactor (node, addLine) {
      if (this.lines.type)       addLine ("Type", node.type);
      if (this.lines.name)       addLine ("Name", node.name);
      if (this.lines.species)    addLine ("Species", node.species.join (" ") );
      if (this.lines.subtype)    addLine ("Subtype", node.subtype);
      if (this.lines.id)         addLine ("ID", node.id);
      if (this.lines.ncbigeneid) addLine ("NCBIGeneID", node.ncbiGeneID);
      if (this.lines.putative)   addLine ("Putative", node.putative);
      if (this.lines.degree)     addLine ("Edges", node.neighbors.length);
      if (this.lines.lifespan)   addLine ("Lifespan Data Available", node.lifespanDataAvailable);

      if (node.lifespanChange !== undefined && node.lifespanChange != 0) {
         if (this.lines.lifespan) addLine ("Lifespan Change", node.lifespanChange);
      }
   }//end Fct



   //------------------------Start fillAlleleType---------------------------------------//
   fillAlleleType (node, addLine) {
      if (this.lines.type)   addLine ("Type", node.type);
      if (this.lines.id)     addLine ("ID", node.id);
      if (this.lines.degree) addLine ("Edges", node.neighbors.length);
   }//end Fct



   //------------------------Start fillCitation-----------------------------------------//
   fillCitation (node, addLine) {
      if (this.lines.type)     addLine ("Type", node.type);
      if (this.lines.id)       addLine ("ID", node.id);
      if (this.lines.database) addLine ("Database", node.database);
      if (this.lines.database) addLine ("Publication ID", node.pubID);
      if (this.lines.degree)   addLine ("Edges", node.neighbors.length);
   }//end Fct



   //------------------------Start fillGeneOntologyTerm---------------------------------//
   fillGeneOntologyTerm (node, addLine) {
      if (this.lines.type)     addLine ("Type", node.type);
      if (this.lines.name)     addLine ("Term", node.term);
      if (this.lines.subtype)  addLine ("Category", node.category);
      if (this.lines.id)       addLine ("ID", node.id);
      if (this.lines.evidence) addLine ("Evidence", node.evidence.join (" ") );
      if (this.lines.degree)   addLine ("Edges", node.neighbors.length);
   }//end Fct



   //------------------------Start fillKEGGPathwayExtraGenes----------------------------//
   fillKEGGPathwayExtraGenes (node, addLine) {
      if (this.lines.type)        addLine ("Type", node.type);
      if (this.lines.name)        addLine ("Symbol", node.symbol);
      if (this.lines.subtype)     addLine ("Subtype", node.subtype);
      if (this.lines.id)          addLine ("ID", node.id);
      if (this.lines.ncbigeneid)  addLine ("NCBIGeneID", node.ncbiGeneID);
      if (this.lines.description) addLine ("Description", node.description);
      if (this.lines.degree)      addLine ("Edges", node.neighbors.length);
   }//end Fct



   //------------------------Start fillObservation--------------------------------------//
   fillObservation (node, addLine) {
      if (this.lines.type)    addLine ("Type", node.type);
      //if (this.lines.species) addLine ("Species", node.species.join (" ") );
      if (this.lines.subtype) addLine ("Subtype", node.subtype);
      if (this.lines.id)      addLine ("ID", node.id);

      if (node.lifespanChange !== undefined && this.lines.lifespan) {
         addLine ("Lifespan Effect Significant", node.lifespanEffectSignificant);
         if (node.lifespanEffectSignificant == "none" || node.lifespanChange == 0)
            addLine ("Lifespan Change", "n/a");
         else
            addLine ("Lifespan Change", node.lifespanChange);
         addLine ("Lifespan Measure", node.lifespanMeasure);
      }

      if (node.homologyDatabase !== undefined && this.lines.homology) {
         addLine ("Homology Database", node.homologyDatabase);
         addLine ("homology Group ID", node.homologyGroupID);
      }
      if (this.lines.degree)  addLine ("Edges", node.neighbors.length);
   }//end Fct



   //------------------------Start fillPathway------------------------------------------//
   fillPathway (node, addLine) {
      if (this.lines.type)        addLine ("Type", node.type);
      if (this.lines.name)        addLine ("Name", node.name);
      if (this.lines.subtype)     addLine ("Subtype", node.subtype);
      if (this.lines.id)          addLine ("ID", node.id);
      if (this.lines.scope)       addLine ("Scope", node.scope);
      if (this.lines.source)      addLine ("Source", node.source);
      if (this.lines.source)      addLine ("Source ID", node.sourceID);
      if (this.lines.source)      addLine ("NCBI Tax ID", node.ncbiTaxID);
      if (this.lines.degree)      addLine ("Edges", node.neighbors.length);
      if (this.lines.description) addLine ("Description", node.description);
   }//end Fct



   //------------------------Start fillSpecies------------------------------------------//
   fillSpecies (node, addLine) {
      if (this.lines.type)   addLine ("Type", node.type);
      if (this.lines.id)     addLine ("ID", node.id);
      if (this.lines.degree) addLine ("Edges", node.neighbors.length);
   }//end Fct
};//end Class
