
//---------------------------Class Menu-------------------------------------------------//
class Menu {
   // Restore constructor
   constructor (memory, node) {
      this.memory = memory;
      this.node  = node;
      this.na = "n/a";

      this.tableCols = {
         AgeingFactor: {name: "Ageing Factor Name", species: "Species", subtype: "Subtype", id: "AgeFactDB ID", ncbiGeneID: "NCBI Gene ID", putative: "Putative", lifespanDataAvailable: "Lifespan Data Available"},
         AlleleType: {id: "Allele Type Name"},
         Citation: {id: "Node ID", database: "Database", pubID: "Database ID"},
         GeneOntologyTerm: {term: "GO Term", category: "Category", id: "GO ID", evidence: "Evidence"},
         KEGGPathwayExtraGenes: {symbol: "Gene Symbol", species: "Species", ncbiGeneID: "NCBI Gene ID", description: "Description"},
         Observation: {subtype: "Subtype", id: "AgeFactDB ID", species: "Species", lifespanEffectSignificant: "Significant Lifespan Effect", lifespanChange: "Lifespan Change [%]", lifespanMeasure: "Lifespan Measure", homologyDatabase: "Homology Database", homologyGroupID: "Homology Group ID"},
         Pathway: {id: "Node ID", description: "Description", scope: "Scope", source: "Source", sourceID: "Source ID", ncbiTaxID: "NCBI Taxonomy ID"},
         Species: {id: "Species Name"}
      };

      this.button = document.createElement ("div");
      this.button.className = "menubutton";
      this.button.appendChild (document.createElement ("div") ).className = "pMbar1";
      this.button.appendChild (document.createElement ("div") ).className = "pMbar2";
      this.button.appendChild (document.createElement ("div") ).className = "pMbar3";
      this.button.addEventListener ("mouseover", event => this.onMainMenuOver (event) );
      this.button.addEventListener ("click", event => this.onMainMenuClick (event) );
      this.node.appendChild (this.button);

      (this.nodeselect = this.node.appendChild (document.createElement ("div") ) ).className = "menunodeselect";
      (this.nodemanip = this.node.appendChild (document.createElement ("div") ) ).className = "menunodemanip";
      (this.search = this.node.appendChild (document.createElement ("div") ) ).className = "menusearch";
      (this.table = this.node.appendChild (document.createElement ("div") ) ).className = "menutable";
      (this.colorselect = this.node.appendChild (document.createElement ("div") ) ).className = "menucolorselect";
      (this.exportgraph = this.node.appendChild (document.createElement ("div") ) ).className = "menuexportgraph";
      (this.info = this.node.appendChild (document.createElement ("div") ) ).className = "menuinfo";

      (this.mainmenu = this.node.appendChild (document.createElement ("div") ) ).className = "mainmenu";
      this.mainmenu.addEventListener ("mouseleave", event => this.onMainMenuOut (event), false);

      this.createMainMenu ();
   }//end Constructor


   //------------------------Start hide-------------------------------------------------//
   hide () {
      this.node.style.setProperty ("display", "none");
   }//end Fct


   //------------------------Start show-------------------------------------------------//
   show () {
      this.node.style.removeProperty ("display");
   }//end Fct


   //------------------------Start createMainMenu---------------------------------------//
   createMainMenu () {
      var ul = document.createElement ("ul");
      var _li = undefined;

      var status = document.createElement ("span");


      // function addLine (html, listener) {
      //    var li = document.createElement ("li");
      //    //var label = document.createElement ("label");
      //    if (html instanceof HTMLElement)
      //       li.appendChild (html);
      //    else li.innerHTML = html;
      //    if (listener)
      //       li.addEventListener ("click", listener);
      //    return ul.appendChild (li);
      // }//end Fct

      function addLine (html, help, listener) {
         _li = document.createElement ("li");
         //var label = document.createElement ("label");
         if (html instanceof HTMLElement)
            _li.appendChild (html);
         else _li.innerHTML = html;
         if (help)
            _li.setAttribute ("x-help", help);
         if (listener)
            _li.addEventListener ("click", listener);
         return ul.appendChild (_li);
      }//end Fct

      addLine ("Show Table", "Show table", () => this.createTable () );
      // addLine ("<label>Export</label><label class='mainmenubtn' x-format='PNG' x-help='Export graph as PNG image'>Graph</label><label class='mainmenubtn' x-format='TABLE' x-help='Show table of visible nodes'>Table</label>", (event) => this.export (event.target.getAttribute ("x-format") ) ); _li.className = "mainmenunobtn";
      addLine ("Export", undefined, event => { var display = event.target.classList.toggle ('active') ? "block" : "none"; var li = ul.getElementsByClassName ("mainmenuexport"); for (var i = 0; i < li.length; ++i) { li[i].style.setProperty ("display", display); } });
      addLine ("Graph", "Export graph as PNG image", () => this.export ("PNG") ); _li.className = "mainmenuexport";
      addLine ("Table", "Show table of visible nodes", () => this.export ("TABLE") ); _li.className = "mainmenuexport";
      addLine ("Change Colors", "Change colors", () => this.createColorSelectMenu () );
      addLine ("Select Nodes", "Open selection menu", () => this.createNodeSelectMenu () );
      addLine ("Manipulate Selection", undefined, () => this.createNodeManipulationMenu () );
      // addLine ("<label x-help='Update layout'>Update Layout<label><span style='float: right; margin-right: 50px;'><input style='width: 42px; direction: rtl;' value='200'></input> steps</span>", event => { if (event.target.nodeName != "INPUT") { this.memory.graph.updateLayout (parseInt(event.originalTarget.getElementsByTagName ("input")[0].value) ); event.stopPropagation(); event.preventDefault(); } }); _li.setAttribute ("x-help", "Update layout");
      addLine ("Layout", "Update layout", event => { var display = event.target.classList.toggle ('active') ? "block" : "none"; var li = ul.getElementsByClassName ("mainmenulayout"); for (var i = 0; i < li.length; ++i) { li[i].style.setProperty ("display", display); } });
      addLine ("D3 (default)", "Apply default D3 Layout", () => { memory.graph.d3ForceLayout("default"); memory.graph.updateLayout (); }); _li.className = "mainmenulayout";
      addLine ("Fruchterman-Reingold", "Apply Fruchterman-Reingold Layout", () => { memory.graph.d3ForceLayout("FR"); memory.graph.updateLayout (); }); _li.className = "mainmenulayout";
      addLine ("Fast Multipole Multilevel Method", "", () => memory.graph.d3ForceLayout("FMMM") ); _li.className = "mainmenulayout";
      addLine ("<label>Update</label><span style='float: right; margin-right: 50px;'><input style='width: 42px; direction: rtl;' value='200'></input> steps</span>", undefined, event => { if (event.target.nodeName != "INPUT") { this.memory.graph.updateLayout (parseInt(layoutbtn.getElementsByTagName ("input")[0].value) ); } }); _li.className = "mainmenulayout"; var layoutbtn = _li;
      addLine ("Stop", "Stop the layout calculation", () => this.memory.graph.stopLayout () ); _li.className = "mainmenulayout";
      addLine ("Freeze Graph", "Stop user interaction", () => this.memory.graph.freeze () );


      ul.addEventListener ("mouseout", () => { this.memory.statusbar.hide () } );
      ul.addEventListener ("mouseover", event => {
         var help = event.target.getAttribute ("x-help");
         if (help) this.memory.statusbar.content = help;
      });

      this.mainmenu.appendChild (status);
      this.mainmenu.appendChild (ul);
   }//end Fct


   //------------------------Start onMainMenuClick--------------------------------------//
   onMainMenuClick (event) {
      this.onMainMenuOver (event);
   }//end Fct


   //------------------------Start onMainMenuOver---------------------------------------//
   onMainMenuOver (event) {
      try {
         var { nodes, links } = this.memory.graph.data;
         this.mainmenu.children[0].textContent = "Nodes: " + nodes.length + ", Edges: " + links.length + ", Sel. Nodes: " + this.memory.select.count[0] + ", Sel. Edges: " + this.memory.select.count[1];
      } catch (e) {}
      this.mainmenu.style.setProperty ("display", "block");
   }//end Fct


   //------------------------Start onMainMenuOut----------------------------------------//
   onMainMenuOut (event) {
      this.mainmenu.style.removeProperty ("display");
   }//end Fct


   //------------------------Start createColorSelectMenu--------------------------------//
   createColorSelectMenu () {
      this.clearColorSelectMenu ();
      var div = document.createElement ("div");
      var div2 = document.createElement ("container");
      var ul = document.createElement ("ul");
      ul.addEventListener ("keyup", event => {
         if (event.target.nodeName != "INPUT") return;

         if (event.target.value.search (/^\s*[0-9.]+\s*,\s*[0-9.]+\s*,\s*[0-9.]+\s*$/) == 0) {
            event.target.nextSibling.style.setProperty ("background-color", "rgb(" + event.target.value + ")");
            return;
         }

         if ( (event.target.value.search (/^[a-zA-Z]+$/) == 0) ||
            (event.target.value.search (/^#[0-9a-fA-F]{3}$/) == 0) ||
            (event.target.value.search (/^#[0-9a-fA-F]{6}$/) == 0) ||
            (event.target.value.search (/^rgb\s*\(\s*[0-9.]+\s*,\s*[0-9.]+\s*,\s*[0-9.]+\s*\)$/) == 0) ||
            (event.target.value.search (/^rgba\s*\(\s*[0-9.]+\s*,\s*[0-9.]+\s*,\s*[0-9.]+\s*,\s*[0-9.]+\s*\)$/) == 0) ||
            (event.target.value.search (/^hsl\s*\(\s*[0-9.]+%?\s*,\s*[0-9.]+%?\s*,\s*[0-9.]+%?\s*\)$/) == 0) )
         event.target.nextSibling.style.setProperty ("background-color", event.target.value);
      });

      function addLine (label, colors, key) {
         var li = ul.appendChild (document.createElement ("li") );
         var lnode = li.appendChild (document.createElement ("label") );
         var inode = li.appendChild (document.createElement ("input") );
         var cnode = li.appendChild (document.createElement ("div") );
         li.setAttribute ("color-key", key);
         lnode.textContent = label;
         cnode.style.cssText = "width: 10px; height: 10px; margin: 6px 6px;";
         cnode.style.setProperty ("background-color", colors[key]);
         inode.style.cssText = "width: 110px; margin: 0px 6px; background-color: transparent;";
         inode.value = colors[key];
      }//end Fct

      addLine ("Background", this.memory.graph.colors, "bg");
      addLine ("AgeingFactor Gene", this.memory.graph.colors, "AgeingFactor_gene");
      addLine ("AgeingFactor Compound", this.memory.graph.colors, "AgeingFactor_compound");
      addLine ("AgeingFactor Other factor", this.memory.graph.colors, "AgeingFactor_other_factor");
      addLine ("AlleleType", this.memory.graph.colors, "AlleleType");
      addLine ("Citation", this.memory.graph.colors, "Citation");
      addLine ("GeneOntologyTerm Component", this.memory.graph.colors, "GeneOntologyTerm_Component");
      addLine ("GeneOntologyTerm Function", this.memory.graph.colors, "GeneOntologyTerm_Function");
      addLine ("GeneOntologyTerm Process", this.memory.graph.colors, "GeneOntologyTerm_Process");
      addLine ("KEGG Pathway Extra Genes", this.memory.graph.colors, "KEGGPathwayExtraGenes");
      addLine ("Observation", this.memory.graph.colors, "Observation");
      addLine ("Observation dec", this.memory.graph.colors, "Observation_dec");
      addLine ("Observation inc", this.memory.graph.colors, "Observation_inc");
      addLine ("Observation lifespan", this.memory.graph.colors, "Observation_lifespan");
      addLine ("Observation Homology analysis", this.memory.graph.colors, "Observation_homology_analysis");
      addLine ("Pathway", this.memory.graph.colors, "Pathway");
      addLine ("Species", this.memory.graph.colors, "Species");
      addLine ("Undefined", this.memory.graph.colors, "default");


      var okay = document.createElement ("div");
      var cancel = document.createElement ("div");

      okay.textContent = "Okay";
      okay.style.cssText = "left: 0px; border-right: 1px solid #555;";
      cancel.textContent = "Cancel";
      cancel.style.cssText = "right: 0px;";

      okay.addEventListener ("click", event => {
         var div = document.createElement ("div");
         for (var i = 0; i < ul.children.length; ++i) {
            var color = ul.children[i].children[1].value;
            if (color.search (/^\s*[0-9.]+\s*,\s*[0-9.]+\s*,\s*[0-9.]+\s*$/) == 0)
               color = "rgb(" + color + ")";
            div.style.setProperty ("color", color);
            if (div.style.getPropertyValue ("color") != "")
               this.memory.graph.colors[ul.children[i].getAttribute("color-key")] = color;
            div.style.removeProperty ("color");
            }//end for
         this.memory.graph.updateColors ();
         this.clearColorSelectMenu ();
      });
      this.clearColorEvtHndl = this.clearColorSelectMenu.bind (this);
      cancel.addEventListener ("click", this.clearColorEvtHndl);
      document.addEventListener ("keyup", this.clearColorEvtHndl);


      this.colorselect.appendChild (div).appendChild (div2).appendChild (ul);
      div.appendChild (okay);
      div.appendChild (cancel);
      this.colorselect.style.setProperty ("display", "block");
   }//end Fct


   //------------------------Start clearColorSelectMenu---------------------------------//
   clearColorSelectMenu (event) {
      if (event && event.type == "keyup" && event.keyCode != 27) return;

      this.colorselect.style.setProperty ("display", "none");

      while (this.colorselect.firstChild)
         this.colorselect.removeChild (this.colorselect.firstChild);

      document.removeEventListener ("keyup", this.clearColorEvtHndl);
   }//end Fct


   //------------------------Start createNodeSelectMenu---------------------------------//
   createNodeSelectMenu () {
      this.clearNodeSelectMenu ();
      var div = document.createElement ("div");

      // Button panel at the bottom
      var panel = document.createElement ("panel");

      var reset = panel.appendChild (document.createElement ("div") );
      var select = panel.appendChild (document.createElement ("div") );
      var filter = panel.appendChild (document.createElement ("div") );
      var close = panel.appendChild (document.createElement ("div") );

      reset.textContent = "Reset";
      select.textContent = "Select";
      filter.textContent = "Filter";
      close.textContent = "Close";


      reset.addEventListener ("click", event => {
         memory.graph.data.nodes.forEach (node => {
            if (node._selected) this.memory.select.remove (node);
         });//end for
         memory.graph.activateNeighbors ();
         //TODO reset labels
      });

      select.addEventListener ("click", event => {
         this.createTable ();
      });

      filter.addEventListener ("click", this.createSearchMenu.bind (this) );


      // Content
      var ul = document.createElement ("ul");

      function addOneLine (label, listener) {
         var li = ul.appendChild (document.createElement ("li") );
         var l1 = li.appendChild (document.createElement ("label") );
         l1.textContent = label;
         li.className = "oneline";
         if (listener) li.addEventListener ("click", listener);
      }//end Fct

      function addLine (label, listener, buttons) {
         if (!buttons) buttons = ["Show", "Hide"];
         var li = ul.appendChild (document.createElement ("li") );
         var l1 = li.appendChild (document.createElement ("label") );   // Replace
         var l2 = li.appendChild (document.createElement ("label") );   // Add
         var l3 = li.appendChild (document.createElement ("label") );   // Remove
         l1.textContent = label; l2.textContent = buttons[0]; l3.textContent = buttons[1];
         l1.setAttribute ("x-mode", "replace"); l2.setAttribute ("x-mode", "add"); l3.setAttribute ("x-mode", "remove");
         if (listener) li.addEventListener ("click", listener);
      }//end Fct


      addLine ("Highlight", function (event) { this.memory.statusbar.error = "Error: not implemented" }.bind (this) );

      addLine ("Visibility", function (event) {
         var mode = event.target.getAttribute ("x-mode");
         var select = this.memory.select;
         if (mode == "add") {
            this.memory.graph.activateNeighbors (select.merge ([select.marked, select.selected]) );
         } else if (mode == "remove") {
            this.memory.graph.activateNeighbors (select.exclude ([select.marked, select.selected]) );
         } else {
            this.memory.graph.activateNeighbors (select.selected);
         }
      }.bind (this) );//end Lambda

      addLine ("Labels", function (event) {
         var mode = event.target.getAttribute ("x-mode");
         if (mode == "add") {
            this.memory.select.selected.forEach (node => this.memory.graph.addNodeLabel (node) );
         } else if (mode == "remove") {
            this.memory.select.selected.forEach (node => this.memory.graph.removeNodeLabel (node) );
         } else {
            this.memory.graph.data.nodes.forEach (node => this.memory.graph.removeNodeLabel (node) );
            this.memory.select.selected.forEach (node => this.memory.graph.addNodeLabel (node) );
         }
      }.bind (this) );


      this.clearNodeEvtHndl = this.clearNodeSelectMenu.bind (this);
      close.addEventListener ("click", this.clearNodeEvtHndl);
      document.addEventListener ("keyup", this.clearNodeEvtHndl);


      this.nodeselect.appendChild (div).appendChild (ul);
      div.appendChild (panel);
      this.nodeselect.style.setProperty ("display", "block");
   }//end Fct


   //------------------------Start clearNodeSelectMenu----------------------------------//
   clearNodeSelectMenu (event) {
      if (event && event.type == "keyup" && event.keyCode != 27) return;
      if (this.table.children.length > 0) return;

      this.nodeselect.style.setProperty ("display", "none");

      while (this.nodeselect.firstChild)
         this.nodeselect.removeChild (this.nodeselect.firstChild);

      document.removeEventListener ("keyup", this.clearNodeEvtHndl);
   }//end Fct


   //------------------------Start createSearchMenu-------------------------------------//
   createSearchMenu () {
      this.clearSearchMenu ();
      var div = document.createElement ("div");

      // Button panel at the bottom
      var panel = document.createElement ("panel");

      var replace = panel.appendChild (document.createElement ("div") );
      var add = panel.appendChild (document.createElement ("div") );
      var remove = panel.appendChild (document.createElement ("div") );
      var close = panel.appendChild (document.createElement ("div") );

      replace.textContent = "Replace"; replace.setAttribute ("x-mode", "replace");
      add.textContent = "Add"; add.setAttribute ("x-mode", "add");
      remove.textContent = "Remove"; remove.setAttribute ("x-mode", "remove");
      close.textContent = "Close";


      var search = (event) => {
         var mode = event.target.getAttribute ("x-mode");
         var nodelist = [];
         for (var i = 0; i < ul.children.length; ++i) {
            var li = ul.children[i];
            if (!li.children[0].children[0].checked) continue;
            var type = li.children[0].getAttribute ("s-type");
            var op = li.children[1].value;
            var value = li.children[2].value;
            nodelist = [...nodelist, ...this.memory.select.searchType (type, op, value)];
         }//end for
         if (mode == "add")
            this.memory.select.addNodes (nodelist);
         else if (mode == "remove")
            this.memory.select.removeNodes (nodelist);
         else
            this.memory.select.selected = nodelist;
         this.clearSearchMenu ();
      };

      replace.addEventListener ("click", search);
      add.addEventListener ("click", search);
      remove.addEventListener ("click", search);


      // Content
      var ul = document.createElement ("ul");

      function addLine (label, type, ops, placeholder) {
         var li = ul.appendChild (document.createElement ("li") );
         var l = li.appendChild (document.createElement ("label") );
         var c = l.appendChild (document.createElement ("input") );
         var s = li.appendChild (document.createElement ("select") );
         var i = li.appendChild (document.createElement ("input") );
         c.type = "checkbox";
         l.appendChild (document.createTextNode (label) );
         l.setAttribute ("s-type", type);
         if (ops)
            ops.forEach (e => s.appendChild (document.createElement ("option") ).textContent = e);
         else
            s.disabled = true;
         if (placeholder === false) i.disabled = true; else if (placeholder === undefined) {} else i.placeholder = placeholder;
         li.addEventListener ("click", function (event) { if (event.target == this) this.children[0].children[0].checked = !this.children[0].children[0].checked });
      }//end Fct

      addLine ("Name", "name");
      addLine ("Degree", "degree", ["==", "!=", ">=", ">", "<=", "<"]);
      addLine ("Property", "property", ["type", "name", "subtype", "id", "ncbiGeneID", "putative", "lifespanDataAvailable", "database", "pubID", "term", "category", "evidence", "symbol", "description", "lifespanEffectSignificant", "lifespanMeasure", "lifespanChange", "homologyDatabase", "homologyGroupID", "scope", "source", "sourceID", "ncbiTaxID", "species"].sort () );
      addLine ("Type", "type", ["AgeingFactor", "AlleleType", "Citation", "GeneOntologyTerm", "KEGGPathwayExtraGenes", "Observation", "Pathway", "Species"], false);
      addLine ("GOI", "goi");
      addLine ("GOI homo base", "goi_ho_base");
      addLine ("Lifespan change", "lifespan", ["==", "!=", ">=", ">", "<=", "<"]);
      addLine ("Neighbors", "neighbors", ["", "AgeingFactor", "AlleleType", "Citation", "GeneOntologyTerm", "KEGGPathwayExtraGenes", "Observation", "Pathway", "Species"], false);
      addLine ("Subnetwork", "subnetwork", undefined, false);
      addLine ("Invert", "invert", ["", "AgeingFactor", "AlleleType", "Citation", "GeneOntologyTerm", "KEGGPathwayExtraGenes", "Observation", "Pathway", "Species"], false);


      this.clearSearchEvtHndl = this.clearSearchMenu.bind (this);
      close.addEventListener ("click", this.clearSearchEvtHndl);
      document.addEventListener ("keyup", this.clearSearchEvtHndl);


      this.search.appendChild (div).appendChild (ul);
      div.appendChild (panel);
      this.search.style.setProperty ("display", "block");
   }//end Fct


   //------------------------Start clearSearchMenu--------------------------------------//
   clearSearchMenu (event) {
      if (event && event.type == "keyup" && event.keyCode != 27) return;
      if (this.table.children.length > 0) return;

      this.search.style.setProperty ("display", "none");

      while (this.search.firstChild)
         this.search.removeChild (this.search.firstChild);

      document.removeEventListener ("keyup", this.clearSearchEvtHndl);
   }//end Fct


   //------------------------Start createNodeManipulationMenu---------------------------//
   createNodeManipulationMenu () {
      this.clearNodeManipulationMenu ();
      var div = document.createElement ("div");

      // Button panel at the bottom
      var panel = document.createElement ("panel");

      var reset = panel.appendChild (document.createElement ("div") );
      var select = panel.appendChild (document.createElement ("div") );
      var filter = panel.appendChild (document.createElement ("div") );
      var close = panel.appendChild (document.createElement ("div") );

      reset.textContent = "Reset";
      select.textContent = "Select";
      filter.textContent = "Filter";
      close.textContent = "Close";


      reset.addEventListener ("click", event => {
         memory.graph.data = memory.graph.allData;
         memory.graph.data.nodes.forEach (node => { if (node.__threeLabel) node.__threeLabel.visible = true; node._deleted = false; });
         //TODO reset labels
      });

      select.addEventListener ("click", event => {
         this.createTable ();
      });

      filter.addEventListener ("click", this.createSearchMenu.bind (this) );


      // Content
      var ul = document.createElement ("ul");

      function addOneLine (label, listener) {
         var li = ul.appendChild (document.createElement ("li") );
         var l1 = li.appendChild (document.createElement ("label") );
         l1.textContent = label;
         li.className = "oneline";
         if (listener) li.addEventListener ("click", listener);
      }//end Fct

      function addLine (label, listener, buttons) {
         if (!buttons) buttons = ["Show", "Hide"];
         var li = ul.appendChild (document.createElement ("li") );
         var l1 = li.appendChild (document.createElement ("label") );   // Replace
         var l2 = li.appendChild (document.createElement ("label") );   // Add
         var l3 = li.appendChild (document.createElement ("label") );   // Remove
         l1.textContent = label; l2.textContent = buttons[0]; l3.textContent = buttons[1];
         l1.setAttribute ("x-mode", "replace"); l2.setAttribute ("x-mode", "add"); l3.setAttribute ("x-mode", "remove");
         if (listener) li.addEventListener ("click", listener);
      }//end Fct


      addLine ("Node size", event => {
         var mode = event.target.getAttribute ("x-mode");
         if (mode == "add")
            this.memory.select.selected.forEach (node => this.memory.graph.resizeNode (node, 0.1) );
         else if (mode == "remove")
            this.memory.select.selected.forEach (node => this.memory.graph.resizeNode (node, -0.1) );
         else
            this.memory.select.selected.forEach (node => this.memory.graph.resizeNode (node, "reset") );
      }, ["Increase", "Decrease"]);

      addLine ("Label size", event => {
         var mode = event.target.getAttribute ("x-mode");
         if (mode == "add")
            this.memory.select.selected.forEach (node => this.memory.graph.resizeNodeLabel (node, 0.1) );
         else if (mode == "remove")
            this.memory.select.selected.forEach (node => this.memory.graph.resizeNodeLabel (node, -0.1) );
         else
            this.memory.select.selected.forEach (node => this.memory.graph.resizeNodeLabel (node, "reset") );
      }, ["Increase", "Decrease"]);

      addLine ("Resize by degree", event => {
         var mode = event.target.getAttribute ("x-mode");
         if (mode == "add")
            this.memory.select.selected.forEach (node => this.memory.graph.resizeNode (node, node.links.length * 0.1) );
         else if (mode == "remove")
            this.memory.select.selected.forEach (node => this.memory.graph.resizeNode (node, node.links.length * -0.1) );
         else
            this.memory.select.selected.forEach (node => this.memory.graph.resizeNode (node, "reset") );
      }, ["Increase", "Decrease"]);

      addLine ("Resize by lifespan", event => {
         var mode = event.target.getAttribute ("x-mode");

         if (mode == "add")
            this.memory.graph.resizeByLO (this.memory.select.selected, 1);
         else if (mode == "remove")
            this.memory.graph.resizeByLO (this.memory.select.selected, -1);
         else
            this.memory.graph.resizeByLO (this.memory.select.selected);
      }, ["Increase", "Decrease"]);

      addOneLine ("Remove nodes from graph", event => {
         var { nodes, links } = this.memory.graph.data;
         var data = { nodes: [...nodes], links: [...links] };
         var selected = this.memory.select.selected;
         selected.forEach (node => {
            if (node.__threeLabel) node.__threeLabel.visible = false;
            data.links = this.memory.select.exclude ([data.links, node.links]);
            node._deleted = true;
         });
         data.nodes = this.memory.select.exclude ([data.nodes, selected]);
         this.memory.graph.data = data;
      });


      this.clearNodeEvtHndl = this.clearNodeManipulationMenu.bind (this);
      close.addEventListener ("click", this.clearNodeEvtHndl);
      document.addEventListener ("keyup", this.clearNodeEvtHndl);


      this.nodemanip.appendChild (div).appendChild (ul);
      div.appendChild (panel);
      this.nodemanip.style.setProperty ("display", "block");
   }//end Fct


   //------------------------Start clearNodeManipulationMenu----------------------------//
   clearNodeManipulationMenu (event) {
      if (event && event.type == "keyup" && event.keyCode != 27) return;
      if (this.table.children.length > 0) return;

      this.nodemanip.style.setProperty ("display", "none");

      while (this.nodemanip.firstChild)
         this.nodemanip.removeChild (this.nodemanip.firstChild);

      document.removeEventListener ("keyup", this.clearNodeEvtHndl);
   }//end Fct


   //------------------------Start createInfoMenu---------------------------------------//
   createInfoMenu () {
      this.clearInfoMenu ();
      var div = document.createElement ("div");


      var close = this.table.appendChild (document.createElement ("div") );
      close.className = "closeinfo";
      close.textContent = "X";
      this.clearInfoMenuEvtHndl = this.clearInfoMenu.bind (this);
      close.addEventListener ("click", this.clearInfoMenuEvtHndl);
      document.addEventListener ("keyup", this.clearInfoMenuEvtHndl);

      this.clearNodeEvtHndl = this.clearInfoMenu.bind (this);
      close.addEventListener ("click", this.clearNodeEvtHndl);
      document.addEventListener ("keyup", this.clearNodeEvtHndl);


      // Content
      var ul = document.createElement ("ul");



      this.info.appendChild (div).appendChild (ul);
      div.appendChild (close);
      this.info.style.setProperty ("display", "block");
   }//end Fct


   //------------------------Start clearInfoMenu----------------------------------------//
   clearInfoMenu (event) {
      if (event && event.type == "keyup" && event.keyCode != 27) return;
      if (this.table.children.length > 0) return;

      this.info.style.setProperty ("display", "none");

      while (this.info.firstChild)
         this.info.removeChild (this.info.firstChild);

      document.removeEventListener ("keyup", this.clearInfoMenu);
   }//end Fct


   //------------------------Start createTable------------------------------------------//
   createTable (visible, nodes) {
      this.clearTable ();
      var _select = this.memory.select;
      var _spinner = this.memory.spinner;

      if (!nodes) nodes = this.memory.graph.data.nodes;
      var count = {}

      var close = this.table.appendChild (document.createElement ("div") );
      close.className = "closetable";
      close.textContent = "X";
      this.clearTableEvtHndl = this.clearTable.bind (this);
      close.addEventListener ("click", this.clearTableEvtHndl);
      document.addEventListener ("keyup", this.clearTableEvtHndl);

      var exportBtn = this.table.appendChild (document.createElement ("div") );
      exportBtn.className = "exporttable";
      exportBtn.textContent = "Export";
      exportBtn.addEventListener ("click", event => { this.exportTable ("EXCEL"); })

      // Create rows
      nodes.forEach (node => {
         // Create header
         if (! this.tables.hasOwnProperty (node.type) ) {
            var table = document.createElement ("table");
            table.border = 1;
            table.setAttribute ("data-type", node.type);
            var thead = table.appendChild (document.createElement ("thead") );
            var tr = thead.appendChild (document.createElement ("tr") );

            for (var key in this.tableCols[node.type]) {
               tr.appendChild (document.createElement ("th") ).textContent = this.tableCols[node.type][key];
            }//end for

            tr.addEventListener ("click", function (event) {
               var nodes = this.parentNode.parentNode.children[1].children;
               if (nodes.length >= 300) _spinner.show ("Updating selection ...");
               setTimeout ( () => {
                  if (!this.classList.contains ("active") ) {
                     for (var i = 0; i < nodes.length; ++i) {
                        nodes[i].classList.add ("active");
                        _select.add (nodes[i].userData);
                     }//end for
                     this.classList.add ("active");
                  } else {
                     for (var i = 0; i < nodes.length; ++i) {
                        nodes[i].classList.remove ("active");
                        _select.remove (nodes[i].userData);
                     }//end for
                     this.classList.remove ("active");
                  }
                  _spinner.hide ();
               }, 20);
            });

            table.appendChild (document.createElement ("tbody") );
            this.tables[node.type] = table;
            this.activeTables.push (node.type);
            count[node.type] = 0;
         }

         // Create row
         var tr = document.createElement ("tr");
         tr.userData = node;

         if (node.type == "Observation") {
            for (var key in this.tableCols[node.type]) {
               if (key == "lifespanChange" && (node.lifespanEffectSignificant == "none" || node.lifespanChange == 0) )
                  tr.appendChild (document.createElement ("td") ).textContent = "n/a";
               else
                  tr.appendChild (document.createElement ("td") ).textContent = node[key];
            }//end for
         } else {
            for (var key in this.tableCols[node.type]) {
               tr.appendChild (document.createElement ("td") ).textContent = node[key];
            }//end for
         }

         if (node._selected === true) tr.classList.add ("active");

         tr.addEventListener ("click", function (event) {
            _select.toggle (this.userData);
            if (this.userData._selected)
               this.classList.add ("active");
            else
            this.classList.remove ("active");
         });

         this.tables[node.type].children[1].appendChild (tr);
         ++count[node.type];
      });//end for

      this.activeTables.sort ();

      var bar = document.createElement ("ul");

      var first = undefined;
      this.activeTables.forEach (table => {
         var btn = bar.appendChild (document.createElement ("li") );
         btn.textContent = table + " (" + count[table] + ")";
         btn.setAttribute ("data-type", table);
         btn.addEventListener ("click", this.onTableBtnClick.bind (this) );
         this.tableBar[table] = btn;
         if (!first) first = table;
      });//end for
      this.table.appendChild (bar);

      var div = this.table.appendChild (document.createElement ("div") );
      this.activeTables.forEach (table => { div.appendChild (this.tables[table]); });//end for

      this.tables[first].style.setProperty ("display", "table");
      this.tableBar[first].classList.add ("active");

      if (visible !== false)
         this.table.style.setProperty ("display", "block");
   }//end Fct


   //------------------------Start clearTable-------------------------------------------//
   clearTable (event) {
      if (event && event.type == "keyup" && event.keyCode != 27) return;

      this.table.style.removeProperty ("display");

      while (this.table.firstChild)
         this.table.removeChild (this.table.firstChild);

      document.removeEventListener ("keyup", this.clearTableEvtHndl);

      this.tables = {};
      this.tableBar = {};
      this.activeTables = [];
   }//end Fct


   //------------------------Start onTableBtnClick--------------------------------------//
   onTableBtnClick (event) {
      this.activeTables.forEach (table => this.tables[table].style.removeProperty ("display") );
      this.activeTables.forEach (table => this.tableBar[table].classList.remove ("active") );

      var curr = event.target.getAttribute ("data-type");

      this.tables[curr].style.setProperty ("display", "table");
      this.tableBar[curr].classList.add ("active");
   }//end Fct


   //------------------------Start export-----------------------------------------------//
   export (format) {
      switch (format) {
      case "PNG": this.exportGraph (); break;
      case "TABLE": this.createTable (true, this.memory.select.marked); break;
      };//end switch
   }//end Fct


   //------------------------Start exportTable------------------------------------------//
   // https://stackoverflow.com/questions/22317951/export-html-table-data-to-excel-using-javascript-jquery-is-not-working-properl
   exportTable (format) {
      if (this.tables === undefined || Object.keys(this.tables).length == 0)
         this.createTable (false);

      switch (format) {
      case "XML": {
      } break;
      case "XLS":
      case "EXCEL": {
         var ua = window.navigator.userAgent;
         var msie = ua.indexOf ("MSIE ");
         var sa;

         this.activeTables.forEach (key => {
            if (this.tables[key].children[0].nodeName != "CAPTION")
               TableExport (this.tables[key]);

            // var table = this.tables[key];
            // console.log (table)
            // if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./)) {     // If Internet Explorer
            //    txtArea1.document.open ("txt/html", "replace");
            //    txtArea1.document.write (table);
            //    txtArea1.document.close ();
            //    txtArea1.focus ();
            //    sa = txtArea1.document.execCommand ("SaveAs", true, "janet.xls");
            // } else                 //other browser not tested on IE 11
            //    sa = window.open ('data:application/vnd.ms-excel,' + encodeURIComponent (table) );
         });//end for

         return (sa);
      } break;
      };//end switch
   }//end Fct


   //------------------------Start exportGraph------------------------------------------//
   exportGraph (format) {
      var div = document.createElement ("div");


      function getSize (value) {
         if (value.search (/^\s*[0-9]+\s*$/) == 0) {
            var value = parseInt (value);
            return [value, value];
         } else if (value.search (/^\s*[0-9]+\s*x\s*[0-9]+\s*$/) == 0) {
            var values = value.split ("x");
            return [parseInt (values[1]), parseInt (values[0])];
         } else throw "";
      };

      var center = document.createElement ("center");
      var snode = document.createElement ("input");
      snode.value = this.memory.graph.canvas.width + " x " + this.memory.graph.canvas.height;
      snode.addEventListener ("focusout", event => {
         try {
            var size = getSize (snode.value);
            snode.value = size[1] + " x " + size[0];
         } catch (e) {
            console.error (e);
            this.memory.statusbar.content = "Error: size format not supported: width x height";
         }
      });


      var okay = document.createElement ("div");
      var cancel = document.createElement ("div");

      okay.textContent = "Okay";
      okay.style.cssText = "left: 0px; border-right: 1px solid #555;";
      cancel.textContent = "Cancel";
      cancel.style.cssText = "right: 0px;";

      okay.addEventListener ("click", event => {
         var size = getSize (snode.value);
         this.memory.graph.export ("PNG", size);
         this.exportgraph.style.setProperty ("display", "none");
      });
      cancel.addEventListener ("click", event => {
         this.exportgraph.style.setProperty ("display", "none");
      });
      snode.addEventListener ("keyup", event =>  { if (event.keyCode == 13) okay.click () });



      while (this.exportgraph.firstChild)
         this.exportgraph.removeChild (this.exportgraph.firstChild);

      this.exportgraph.appendChild (div).appendChild (center).appendChild (snode);
      div.appendChild (okay);
      div.appendChild (cancel);
      this.exportgraph.style.setProperty ("display", "block");
   }//end Fct

};//end Class
