
//---------------------------Class Statusbar--------------------------------------------//
class Statusbar {
   // Restore constructor
   constructor (memory, node) {
      this.memory = memory;
      this.node  = node;
      this.timeout = undefined;
   }//end Constructor


   //------------------------Getter content---------------------------------------------//
   get content () {
      return this.node.textContent;
   }//end Fct


   //------------------------Setter content---------------------------------------------//
   set content (msg) {
      this.node.textContent = msg;
      this.node.style.setProperty ("display", "block");
      this.time = 10;
   }//end Fct


   set error (msg) {
      if (msg instanceof Error) {
         this.node.textContent = msg.toString ();
         console.error (msg);
      } else {
         this.node.textContent = msg;
         console.error (msg);
      }

      this.node.style.setProperty ("display", "block");
      this.time = 30;
      this.memory.spinner.hide ();
   }//end Fct


   //------------------------Setter timeout---------------------------------------------//
   set time (seconds) {
      clearTimeout (this.timeout);
      this.timeout = setTimeout ( () => this.hide (), seconds * 1000);
   }//end Fct


   //------------------------Start hide-------------------------------------------------//
   hide () {
      this.node.style.setProperty ("display", "none");
      clearTimeout (this.timeout);
   }//end Fct


   //------------------------Start show-------------------------------------------------//
   show () {
      this.node.style.setProperty ("display", "block");
      clearTimeout (this.timeout);
   }//end Fct
};//end Class
