$( function() {
   $( "#tabs" ).tabs();
} );


$(document).ready(function () {
   var restable;
   var targetBoxinit = $(".geneE");
   var annotationNodes = {allele: undefined, citation: undefined, homology: undefined, species: undefined, gobp: undefined, gomf: undefined, gocc: undefined, keggpw: undefined, keggeg: undefined};
   $(".ddm").not(targetBoxinit).hide();
   $(targetBoxinit).show();


   // Remember how an annotation is set by user cross all tabs
   // $("#tabs > ul a[href='#tabs-1']").click (function () {
   //    $(".check_annos input").each ( () => {
   //       this.checked = annotationNodes[this.value] !== undefined ? annotationNodes[this.value] : false;
   //    });//end for
   // });


   // $("#tabs > ul a[href='#tabs-3']").click (function () {
   //    $(".check_annos_nw input").each ( () => {
   //       this.checked = annotationNodes[this.value] !== undefined ? annotationNodes[this.value] : false;
   //    });//end for
   // });


   // $("#tabs > ul a[href='#tabs-7']").click (function () {
   //    $(".check_annos_rt input").each ( () => {
   //       this.checked = annotationNodes[this.value] !== undefined ? annotationNodes[this.value] : false;
   //    });//end for
   // });


   // $(".check_annos input, .check_annos_nw input, .check_annos_rt input").click (function (event) {
   //    annotationNodes[this.value] = this.checked;
   //    console.log (event)
   // });


   // Remember how an annotation is set by user
   $(".check_annos input").click (function (event) {
      annotationNodes[this.value] = this.checked;
   });


   //
   $('.select-AF > button[type="button"]').click(function () {
      var inputValue = $(this).attr("value");
      var targetBox = $("." + inputValue);
      $(".ddm").not(targetBox).hide();   // Hide other elements
      $(targetBox).show();

      $(".check_annos input").each (function () {
         this.checked = annotationNodes[this.value] !== undefined ? annotationNodes[this.value] : false;
      });//end for

      // Set default values for annotation Nodes
      $(".check_annos input[value='allele']")[0].checked = annotationNodes.allele !== undefined ? annotationNodes.allele : true;
      $(".check_annos input[value='citation']")[0].checked = annotationNodes.citation !== undefined ? annotationNodes.citation : true;

      if (inputValue == "chemcom" || inputValue == "other")
         $(".check_annos input[value='species']")[0].checked = annotationNodes.species !== undefined ? annotationNodes.species : true;
   });


   // Mark select-AF-type button active
   $('.select-AF > button[type="button"]').click(function () {
      $('button[type="button"]').removeClass("active");
      $(this).addClass("active");
   });


   // Handle click on "Select all" control
   $('#tab-select-all').on('click', function () {
      // Get all rows with search applied
      var rows = restable.rows({ 'search': 'applied' }).nodes();
      // Check/uncheck checkboxes for all rows in the table
      if (this.checked)
         $(rows).addClass('selected');
      else
         $(rows).removeClass('selected');
   });



   // Handle click on row to set state of "Select all" control
   $('#resulttab tbody').on('click', 'tr', function () {
      $(this).toggleClass('selected');
   });


   // Upload GOI, create result table
   $('#upload').click(function () {
      $("#tab-select-all").prop("checked", false);
      $('#resulttab').DataTable().destroy();
      //var data = $.ajax({ type: 'POST', url: new RequestList({ type: "GOI" }), data: $('#ugenelist').val(), contentType: "text/plain", async: false }).responseJSON;
      RequestList ({type: 'GOI'}, { data: $('#ugenelist').val() }).async (function (data) {
         restable = $('#resulttab').DataTable({
            dom: 'lBfrtip',
            buttons:[ 'copyHtml5', 'excelHtml5', 'csvHtml5', 'print', {extend: 'columnsToggle', columns: '.toggle', className: 'visiButton'}],
            data: $.map(data.data, function (value, key) { return value; }),
            "dataSrc": "data",
            "lengthMenu": [[10, 25, 50, -1], [10, 25, 50, "All"]],
            columnDefs: [{
               'targets': [0],
               'searchable': false,
               'orderable': false,
               'className': 'dt-body-center',
               'render': function (data, type, row, meta) {
                  return '';
               },
            },
            { "width": "5%", "targets": 8 },
            { "width": "5%", "targets": 9 },
            {
               // "targets": 10,
               "targets": 9,
               "width": "50%",
               'render': function (data, type, row, meta) {
                  if (typeof (data) == "string") return data;
                  var dnode = document.createElement ("div");
                  data.forEach (af => {
                     if (dnode.title.length) dnode.title += "\n";
                     dnode.title += "based on gene " + af.name + " " + af.species + " (NCBI Gene ID " + af.ncbiGeneID + ", " + af.id + ")";
                  });
                  dnode.textContent = "homology analysis with " + data.length + " base AFs";
                  return dnode.outerHTML;
               },
            },
            {
               "targets": 10,
               "width": "50%",
               'render': function (data, type, row, meta) {
                 if (typeof (data) == "string") return "";
                  var tdnode = document.createElement ("div");
                  data.forEach (af => {
                  if (tdnode.textContent.length) tdnode.textContent += "\n";
                     tdnode.textContent += "based on gene " + af.name + " " + af.species + " (NCBI Gene ID " + af.ncbiGeneID + ", " + af.id + ")";
                  });
                  return tdnode.outerHTML;
               },
            }
          ],
            select: {
               style: 'os',
               selector: 'td:first-child'
            },
            "columns": [
               { "data": "matchNumber" },
               { "data": "goiSymbol" },
               { "data": "goiSpecies" },
               { "data": "goiNcbiGeneID" },
               { "data": "afID" },
               { "data": "afSymbol" },
               { "data": "afSpecies" },
               { "data": "afNcbiGeneID" },
               { "data": "afPutative" },
               { "data": "afEvidence" },
               { "data": "afEvidence" }
            ],
            "createdRow": function (row, data, index) {
              // td for INFO

               if (data["afPutative"] == false) {
                  $('td', row).addClass('btn-experiment');
                  $(row).attr('data-status', 'experiment');
               } else {
                  $('td', row).addClass('btn-putative');
                  $(row).attr('data-status', 'putative');
               }
            }
         });
         $('#resulttab').addClass('table-condensed');
         $('.dt-button').addClass('expbtn');
      }).catch (reason => console.error (reason) );


      $('#tabs a[href="#tabs-7"]').click ();
      $('#resulttable-message').hide();
      $('#resulttable').show();
   });

   //

   //


   //
   $('#tabvisualize').click(function () {
      var tabjanet = [];
      restable.rows('.selected').data().each(node => tabjanet.push (node.afID) );

      tabjanet = tabjanet.join(',');
      var rtannos = getcheckedrtannos();

      visualize(RequestSearch({ type: "AF", id: tabjanet, nodes: rtannos, depth: false }));

      return false;
   });


   //
   $('#overviewvisualize').click(function () {
      var tabjanet = [];
      restable.rows().data().each(node => {
         tabjanet.push ("GOI:" + node.afID);
         if (node.afEvidence instanceof Array)
            node.afEvidence.forEach (e => tabjanet.push (e.id) );
      });
      tabjanet = tabjanet.join(',');

      visualize(RequestSearch({ type: "AFN", id: tabjanet }));

      return false;
   });


   //
   $('#netvisualize').click(function () {
      var nwjanet = [];
      //$('.select-AF > button[type="button"].active').each(function () { });
      nwjanet[0] = getcheckedaf();   // AF subtype
      nwjanet[1] = $("#filter_NW").val();  // Species
      nwjanet[2] = getcheckednwannos();   // Nodes

      nwjanet[1] = nwjanet[1] == "All" ? "" : nwjanet[1];

      visualize(RequestSearch({ type: "AAF", subtype: nwjanet[0], species: nwjanet[1], nodes: nwjanet[2] }));
   });


   //
   $('#visualize').click(function () {
      var gsel = '';
      var janet = [];
      $('.select-AF > button[type="button"].active').each(function () {
         gsel = $(this).attr('id');
      });

      switch (gsel) {
         case "gene_ex":
            {
               janet[0] = "GENE_EXP";
               janet[1] = $("#selectdd_AFGE").val();
               break;
            }
         case "gene_pu":
            {
               janet[0] = "GENE_PUT";
               janet[1] = $("#selectdd_AFGP").val();
               break;
            }
         case "chemcom":
            {
               janet[0] = "CHEMCOMP";
               janet[1] = $("#selectdd_AFCP").val();
               break;
            }
         case "other":
            {
               janet[0] = "OTHER";
               janet[1] = $("#selectdd_AFO").val();
               break;
            }
         default:
            {
               janet[0] = "FAIL!";
               janet[1] = "FAIL!";
               console.log("DEF!");
            }
      }

      janet[2] = $('#neighbour_c').is(':checked');
      janet[3] = getcheckedannos();

      visualize(RequestSearch({ type: "AF", id: janet[1], nodes: janet[3], depth: janet[2] }));
   });


   //
   function getcheckedannos() {
      /* declare an checkbox array */
      var chkArray = [];
      $(".check_annos:checked").each(function () {
         chkArray.push($(this).val());
      });
      return chkArray.join(',');
   }


   //
   function getcheckednwannos() {
      var chkArray = [];
      $(".check_annos_nw:checked").each(function () {
         chkArray.push($(this).val());
      });
      return chkArray.join(',');
   }


   //
   function getcheckedrtannos() {
      var chkArray = [];
      $(".check_annos_rt:checked").each(function () {
         chkArray.push($(this).val());
      });
      return chkArray.join(',');
   }


   //
   function getcheckedaf() {
      /* declare an checkbox array */
      var chkArray = [];
      if ($('#nw_genes_ex').prop('checked')) {
         chkArray.push("GENES_EXP");
      }
      if ($('#nw_genes_pu').prop('checked')) {
         chkArray.push("GENES_PU");
      }
      if ($('#nw_cp').prop('checked')) {
         chkArray.push("CHEMCOMP");
      }
      if ($('#nw_other').prop('checked')) {
         chkArray.push("OTHER");
      }
      return chkArray.join(',');
   }


   //
   $('div .checkbox').click(function () {
      checkedState = $(this).attr('checked');
      $(this).parent('div').children('.checkbox:checked').each(function () {
         $(this).attr('checked', false);
      });
      $(this).attr('checked', checkedState);
   });


   //
   $('.ckbox label').on('click', function () {
      $(this).parents('tr').toggleClass('selected');
   });


   //
   $('.btn-filter').on('click', function () {
      var $target = $(this).data('target');
      if ($target == 'all') {
         $('.table tr').css('display', 'none').fadeIn('fast');
      } else {
         $('.table tr').css('display', 'none');
         $('.table tr[data-status="' + $target + '"]').fadeIn('fast');
      }
      $('.table tr:first').fadeIn('fast');
   });


   //
   $('.fakeSelect-entry').each(function (p, node) {
      node = $(node);
      node.append(addSelect(node.attr('select-id'), node.attr('select-default')));
   })



   // Load all the data
   $('#viewer_script').load (function () {
      janet__main();
   });
});
