
//---------------------------Start dd_fill----------------------------------------------//
function dd_fill (id_dd, data, subtype) {
   var node = $(id_dd + "_select");
   var data = data[subtype];
   data.sort ( (a,b) => a.gene_symbol.localeCompare (b.gene_symbol) );
   var i = 0;

   var interval = setInterval ( () => {
      for (var n = 0; i < data.length && n < 300; ++i, ++n)
         node.append ($('<li></li>').attr ('data-value', data[i].id).attr ('href', "#").text (data[i].gene_symbol + " (" + data[i].id + ", " + data[i].species + ")") );

      if (i >= data.length)
         clearInterval (interval);
   }, 100);
}//end Fct



//---------------------------Start dd_fill2---------------------------------------------//
function dd_fill2 (id_dd, data, subtype) {
   var node = $(id_dd + "_select");
   var data = data[subtype];
   data.sort ( (a,b) => a.id.localeCompare (b.id) );

   $.each(data, function (key, entry) {
      node.append ($('<li></li>').attr ('data-value', entry.id).attr ('href', "#").text (entry.id) );
   });
}//end Fct



//---------------------------Start dd_filter--------------------------------------------//
function dd_filter (id_filter, id_target) {
   $(id_filter + "_select").click(function (event) {
      if (event.target.nodeName == "LI") {
         var filterValue = $(event.target).data ('value');
         if (filterValue === "All") {
            $(id_target + "_select li").show();
         } else {
            $(id_target + "_select li").hide();
            $(id_target + "_select li:contains(" + filterValue + ")").show();
         }
      }
   });
}//end Fct



//---------------------------Start visualize--------------------------------------------//
function visualize (request) {
   $('#tabs a[href="#tabs-4"]').click ();

   if (window.memory === undefined) {
      var graph_container = document.getElementById ("graph-container");
      graph_container.innerHTML = "";
      window.memory = new GraphContainer (graph_container);
      window.memory.node.style.height = (window.innerHeight - 200) + "px";
      $(window).resize (function (event) {
         window.memory.node.style.height = (window.innerHeight - 200) + "px";
      });
   }

   memory.graph.createGraph (request);
}//end Fct



//---------------------------Start addSelect--------------------------------------------//
function addSelect (id, default_) {
   var dnode = $('<div class="btn-group dropdown fakeSelect"></div>');
   var bnode = $('<button type="button" id="' + id + '_btn" class="btn btn-default dropdown-toggle" data-toggle="dropdown" aria-expanded="true"></button>')
      .append ($('<span class="currentVal">' + default_ + '</span>') )
      .append ($('<span class="caret"></span>') );
   var ulnode = $('<ul id="' + id + '_select" class="dropdown-menu" role="menu" aria-labelledby="' + id + '_btn"></ul>')
      .append ($('<li data-value="' + default_ + '" href="#">' + default_ + '</li>') );
   var inode = $('<input id="' + id + '" type="hidden" class="selectValue" value="' + default_ + '" />');

   dnode.append (bnode).append (ulnode).append (inode);

   dnode.click (function (event) {
      if (event.target.nodeName == "LI") {
         $(event.currentTarget).find('.currentVal').text($(event.target).text () );
         $(event.currentTarget).find('.selectValue').val($(event.target).data ('value') );
      }
   });

   return dnode;
}//end Fct



//---------------------------Start janet__main------------------------------------------//
function janet__main () {
   // dd_fill('#filter_AFGE','api/list?type=AF&subtype=gE&property=species');
   $('#backbutton').hide();

   // REST
   $.getJSON (RequestSpecial ({type: "startup"}), data => {
      dd_fill2('#filter_AFGE',data,"species_gE");
      dd_fill2('#filter_AFGP',data,"species_gP");
      dd_fill2('#filter_AFCP',data,"species_cp");
      dd_fill2('#filter_AFO',data,"species_of");
      dd_fill('#selectdd_AFGE',data,"gE");
      dd_fill('#selectdd_AFGP',data,"gP");
      dd_fill('#selectdd_AFCP',data,"chemcomp");
      dd_fill('#selectdd_AFO',data,"other");

      dd_filter('#filter_AFGE','#selectdd_AFGE');
      dd_filter('#filter_AFGP','#selectdd_AFGP');
      dd_filter('#filter_AFCP','#selectdd_AFCP');
      dd_filter('#filter_AFO','#selectdd_AFO');
   });

   $.getJSON (RequestList ({type: "Species"}), data => {
      dd_fill2('#filter_NW', data, "nodes");
   });

   $('#resulttable').hide();
}//end Fct
