"""JANet graph layouting functionality
"""

import os
import io
import hashlib
import json
import shlex
import sqlite3
import subprocess
import time



##---------------------------SQLite Database---------------------------------------##
class SQL:
   def __init__ (self):
      self.conn = sqlite3.connect ("data/GraphLayout.db")

   def __del__(self):
      self.conn.close ()

   def cursor (self):
      return self.conn.cursor ()

   def commit (self):
      return self.conn.commit ()



sql = SQL ()


##---------------------------Start computeLayout-----------------------------------##
def computeLayout (nodes, edges, layout = "FMMM", options = None):
   success = loadFromCache (nodes, edges, layout, options)

   if success:
      return

   elif layout == "FMMM":
      program = "ssh cerebellum compute-fmmm-layout.sh"

      command = shlex.split (program)

      bio = ""
      for edge in edges:
         bio +=  '"' + edge['source'] + '"\t"' + edge['target'] + '"\n'


      output = subprocess.Popen (command, stdin = subprocess.PIPE, stdout = subprocess.PIPE).communicate (input = bio.encode("ASCII") )[0]

      output = json.loads (output.decode ('ASCII') )


      mapping = {}
      for n in output['nodes']:
         mapping[n['name'] ] = {'x': n['x'], 'y': n['y'], 'z': n['z']}


      for node in nodes:
         n = mapping[node['id'] ]
         node['x'] = n['x'] / 1.5
         node['y'] = n['y'] / 1.5
         node['z'] = n['z'] / 1.5

   # if layout == "FMMM":
   #    program = "xvfb-run -s '+extension GLX -screen 0 1024x1024x24' -a /opt/Java/10.0.2/jre/bin/java -jar /var/www/janet/test/BLE3D-3.3-batch.jar"
   #    arguments = {}
   #    arguments["fmmm_desired_edge_length"] = "100.0"
   #    arguments["fmmm_force_model"] = "EADES"
   #    arguments["fmmm_iteration_level_factor"] = "10"
   #    # arguments["fmmm_quality_vs_speed"] = "VERY_HIGH_QUALITY_VERY_LOW_SPEED"
   #    arguments["fmmm_quality_vs_speed"] = "MEDIUM_QUALITY_MEDIUM_SPEED"
   #    arguments["fmmm_stop_criterion"] = "FORCE_THRESHOLD_AND_FIXED_ITERATIONS"
   #    arguments["graph_layout_algorithm"] = "FMMM"
   #    arguments["burst_layout_iterations"] = "20"
   #    arguments["kvalue_modifier"] = "1.0"
   #    arguments["minimum_component_size"] = " 1"
   #    arguments["renderer_mode_start_3d"] = "true"
   #    arguments["show_layout_iterations"] = "false"
   #    arguments["starting_temperature"] = "100.0"
   #    arguments["tile_screen_factor"] = "5"
   #    arguments["tiled_layout"] = "true"
   #    arguments["use_layout_n_core_parallelism"] = "true"
   #    arguments["number_of_layout_iterations"] = "10"

   #    command = shlex.split (program)
   #    command.append ("-batch")
   #    for k, v in arguments.items():
   #       command.extend (["-usePreference", k, v])

   #    command.append ("/var/run/JANet2/fmmm.txt")
   #    # command.append ("/proc/self/fd/0")

   #    env = os.environ
   #    env['MESA_GL_VERSION_OVERRIDE'] = '3.1'


   #    # ogdf = "graph [\n"
   #    # for node in nodes:
   #    #    ogdf += "node [ id " + node['id'] + " type " + node['type'] + " ]\n"
   #    # for edge in edges:
   #    #    ogdf += "edge [ source " + edge['source'] + " target " + edge['target'] + " ]\n"
   #    # ogdf += "]\n"

   #    bio = ""
   #    for edge in edges:
   #       bio +=  '"' + edge['source'] + '"\t"' + edge['target'] + '"\n'


   #    with open ("/var/run/JANet2/fmmm.txt", "w") as file:
   #       file.write (bio)


   #    # print (" ".join (command) )
   #    # subprocess.Popen (command, stdout = subprocess.PIPE, env = env).communicate ()
   #    subprocess.run (command, stdout = subprocess.PIPE, env = env)
   #    # # output = subprocess.Popen (command, stdin = subprocess.PIPE, stdout = subprocess.PIPE, env = env).communicate (input = ogdf.encode("ASCII", "ignore") )[0]
   #    # # output = subprocess.Popen (command, stdin = subprocess.PIPE, stdout = subprocess.PIPE, env = env, encoding = "UTF-8").communicate (input = ogdf)[0]
   #    # print (output)

   #    with open ("/var/run/JANet2/fmmm.txt-layout.txt", "r") as file:
   #       output = json.loads (file.read () )


   #    mapping = {}
   #    for n in output['nodes']:
   #       mapping[n['name'] ] = {'x': n['x'], 'y': n['y'], 'z': n['z']}


   #    for node in nodes:
   #       n = mapping[node['id'] ]
   #       node['x'] = n['x'] / 1.5
   #       node['y'] = n['y'] / 1.5
   #       node['z'] = n['z'] / 1.5

   # elif layout == "FM^3 (ogdf)"
   #    graph = tlp.newGraph()

   #    graph.setAttribute ("threeD", 100)

   #    N1 = {}
   #    N2 = {}

   #    for node in nodes:
   #       tlpNode = graph.addNode (node)
   #       N1[node['id'] ] = tlpNode   # Memorize id with tulip node
   #       N2[tlpNode] = node


   #    for edge in edges:
   #       src = N1[edge['source'] ]
   #       tgt = N1[edge['target'] ]
   #       graph.addEdge (src, tgt)


   #       tlp.saveGraph (graph, '/tmp/graph.tlp')

   #       size = 100
   #       viewLayout = graph.getLayoutProperty ("viewLayout")

   #       for n in graph.getNodes():
   #          x = random.random() * size
   #          y = random.random() * size
   #          z = random.random() * size
   #          viewLayout[n] = tlp.Coord(x, y, z)



   #    layout = 'Random layout'

   #    params = tlp.getDefaultPluginParameters (layout, graph)

   #    params['iterno'] = 20
   #    params['reqlength'] = 0.5
   #    params['Fixed iterations'] = 3000
   #    params['Threshold'] = 0.0001
   #    params['Unit edge length'] = 30
   #    params['New initial placement'] = False
   #    params['Quality vs Speed'] = 'GorgeousAndEfficient'
   #    params['Pre Sort'] = 'None'
   #    params['Galaxy Choice'] = 'UniformProb'
   #    params['Force Model'] = 'FruchtermanReingold'
   #    params['Reduced Tree Construction'] = 'PathByPath'
   #    params['Smallest Cell Finding'] = 'Aluru'
   #    params['3D layout'] = True


   #    success = graph.applyLayoutAlgorithm (layout, params)


   #    viewLayout = graph.getLayoutProperty ("viewLayout")

   #    for tlpNode in graph.getNodes ():
   #       pos = viewLayout[tlpNode]
   #       node = N2[tlpNode]
   #       node['x'], node['y'], node['z'] = pos

   else:
      return

   storeInCache (nodes, edges, layout, options)



##---------------------------Start loadFromCache-----------------------------------##
def loadFromCache (nodes, edges, layout, options):
   #c = sql.cursor ()
   conn = sqlite3.connect ("data/GraphLayout.db")
   c = conn.cursor ()

   # SQLite Database
   c.execute("SELECT name FROM sqlite_master WHERE type = 'table' AND name = ?;", (layout,) )

   if len (c.fetchall () ) == 0:
      return


   hash = hashlib.md5 ()
   request = ""
   options = options or ""

   nodelist = []
   edgelist = []

   for node in nodes:
      nodelist.append (node['id'])

   for edge in edges:
      edgelist.append (edge['source'] + " " + edge['target'])

   nodelist.sort ()
   edgelist.sort ()

   for msg in nodelist + edgelist:
      request += msg + " "

   hash.update (request.encode('utf-8') )

   #TODO search for hash first
   c.execute ("SELECT response FROM " + layout + " WHERE hash = ? AND options = ? AND request = ?;", (hash.digest (), options, request,) )

   response = c.fetchone ()

   nodedict = {}

   if response:
      for line in io.StringIO (response[0]):
         res = line.split ("\t")
         id, pos = res[0], res[1:]
         nodedict[id] = pos

      for node in nodes:
         n = nodedict[node['id'] ]
         node['x'] = float (n[0])
         node['y'] = float (n[1])
         node['z'] = float (n[2])

      return True



##---------------------------Start storeInCache------------------------------------##
def storeInCache (nodes, edges, layout, options):
   #c = sql.cursor ()
   conn = sqlite3.connect ("data/GraphLayout.db")
   c = conn.cursor ()

   # Advanced Databases
   # c.execute ("""
   #    IF (NOT EXISTS (SELECT *
   #                   FROM INFORMATION_SCHEMA.TABLES
   #                   WHERE TABLE_NAME = 'fmmm') )
   #    BEGIN
   #       CREATE TABLE """ + layout + """ (hash text, request text, response text, timestamp smalldatetime)
   #    END
   # """)

   # SQLite Database
   c.execute("SELECT name FROM sqlite_master WHERE type = 'table' AND name = ?;", (layout,) )

   if len (c.fetchall () ) == 0:
      c.execute ("CREATE TABLE " + layout + " (hash text, request text, options text, response text, timestamp smalldatetime);")
      c.fetchall ()


   hash = hashlib.md5 ()
   request = ""
   response = ""
   options = options or ""

   nodelist = []
   edgelist = []

   for node in nodes:
      nodelist.append (node['id'])

   for edge in edges:
      edgelist.append (edge['source'] + " " + edge['target'])

   nodelist.sort ()
   edgelist.sort ()

   for msg in nodelist + edgelist:
      request += msg + " "

   for node in nodes:
      response += node['id'] + "\t" + str (node['x']) + "\t" + str (node['y']) + "\t" + str (node['z']) + "\n"

   hash.update (request.encode('utf-8') )

   c.execute ("INSERT INTO " + layout + " VALUES (?, ?, ?, ?, ?);", (hash.digest (), request, options, response, str(int(time.time() ) ),) )

   #sql.commit ()
   conn.commit ()
