"""JANet search functionality
"""

import os, sys
import re

BASE_DIR = os.path.dirname (os.path.dirname (os.path.abspath (__file__) ) )
sys.path.insert (0, os.path.join (BASE_DIR, "Tools") )

from Arguments import Arguments
from Neo4j import Neo4j


neo4j = Neo4j ()

__all__ = ["resolveGenesOfInterest"]



##---------------------------Start resolveGenesOfInterest--------------------------##
def resolveGenesOfInterest (response, GOIs):
   response['data'] = result = []
   response['GOI'] = AF = []   # Found GOIs


   def fillRow (result, records, GOI):
      for record in records:
         AF.append (record['af']['id'])

         match = Arguments ()
         match.matchNumber = len (AF)
         # match.goiSymbol = record['AF_name'] if 'AF_name' in record.keys() else ""
         # match.goiSpecies = record['SP_id'] if 'SP_id' in record.keys() else ""
         # match.goiNcbiGeneID = record['AF_ncbi_gene_id'] if 'AF_ncbi_gene_id' in record.keys() else ""
         match.goiSymbol = GOI['AF_name'] if 'AF_name' in GOI else ""
         match.goiSpecies = GOI['SP_id'] if 'SP_id' in GOI else ""
         match.goiNcbiGeneID = GOI['AF_ncbi_gene_id'] if 'AF_ncbi_gene_id' in GOI else ""
         match.afID = record['af']['id']
         match.afSymbol = record['af']['name']
         match.afSpecies = record['af']['species']
         match.afNcbiGeneID = record['af']['ncbiGeneID']
         match.afPutative = record['af']['putative']
         match.afHomologyBaseIDs = []

         if match.afPutative == False:
            match.afEvidence = "experimental evidence"
         else:
            match.afEvidence = []

            for record2 in neo4j.eval ("MATCH (af)--(ob:Observation {subtype: 'homology_analysis'}) WHERE id(af) = %d RETURN distinct ob" % (record['af'].id) ):
               # match.afHomologyBaseIDs.append (record2['ob']['id'])

               if match.afPutative == True:
                  for record3 in neo4j.eval ("MATCH (ob)--(af:AgeingFactor {lifespanDataAvailable: true}) WHERE id(ob) = %d RETURN distinct af" % (record2['ob'].id) ):
                     #match.afEvidence += "based on gene " + record3['af']['name'] + " " + str (record3['af']['species']) + "(NCBI Gene ID " + record3['af']['ncbiGeneID'] + "," + record3['af']['id'] + ")"
                     match.afEvidence.append ({'id': record3['af']['id'], 'name': record3['af']['name'], 'species': record3['af']['species'], 'ncbiGeneID': record3['af']['ncbiGeneID']})


         result.append (match.__dict__)


   # nameGOIs = [GOI['AF_name'] for GOI in GOIs if 'AF_name' in GOI]
   # ncbiGOIs = [GOI['AF_ncbi_gene_id'] for GOI in GOIs if 'AF_ncbi_gene_id' in GOI]

   # Sort by species
   #records = neo4j.eval ("WITH {nameGOIs} as GOIs UNWIND GOIs as GOI MATCH (af:AgeingFactor {subtype: 'gene'})-[:has_sp]->(sp:Species {id: GOI.SP_id}) WHERE af.name = GOI.AF_name OR GOI.AF_name in af.synonyms RETURN distinct af", nameGOIs = nameGOIs)
   # records = neo4j.eval ("MATCH (af:AgeingFactor {subtype: 'gene'}) WHERE af.name in {AF_name} RETURN distinct af", AF_name = nameGOIs)
   # fillRow (result, records, {})

   # records = neo4j.eval ("MATCH (af:AgeingFactor {subtype: 'gene'}) WHERE af.ncbiGeneID in {ncbiGOIs} RETURN distinct af, af.ncbiGeneID as AF_ncbi_gene_id", ncbiGOIs = ncbiGOIs)
   # fillRow (result, records, {})


   for GOI in GOIs:
      if 'AF_name' in GOI:
         records = neo4j.eval ("MATCH (af:AgeingFactor {subtype: 'gene'})-[:has_sp]->(sp:Species {id: '%s'}) WHERE af.name = '%s' OR '%s' in af.synonyms RETURN distinct af" % (GOI['SP_id'], GOI['AF_name'], GOI['AF_name']) )

         fillRow (result, records, GOI)

      else:
         records = neo4j.eval ("MATCH (af:AgeingFactor {ncbiGeneID: '%s', subtype: 'gene'}) RETURN distinct af" % (GOI['AF_ncbi_gene_id']) )

         fillRow (result, records, GOI)


   response['summary'] = {'matchCount': len (AF), 'goiCount': len (GOIs) }

   return response
